unit BMGSpriteGenerator;

interface
uses KOL,BMaxGTypes,BMGSpriteCollection;
const l0cmin=4;
const l0cmax=7;
const l0max=11;//l0 = 12x12 1=4 1c=16x16pix
const l2cmin=8;
const l2cmax=15;
const l2max=23;//l2 = 24x24 1=8 1c=8x8pix
const l3cmin=16;
const l3cmax=31;
const l3max=47;//l3 = 48x48 1=16 1c=4x4pix
const l4cmin=32;
const l4cmax=63;
const l4max=95;//l4 = 96x96 1=32 1c=2x2pix
const l5cmin=64;
const l5cmax=127;
const l5max=191;//l4 = 192x192 1=64 1c=1pix

type tgenIN=array [0..15,0..15]of byte;//4x4 1=16
type tgenIN2=array [0..31,0..31]of byte;//4x4 1=16

type tgenl0=array [0..l0max,0..l0max]of byte;//4x4 1=16
type tgenl2=array [0..l2max,0..l2max]of byte;//8x8 1=8
//type tgenl3=array [0..l3max,0..l3max]of byte;//16x16 1=4
type tgenmask=record
   mskin:tgenIN;
   mskin2:tgenIN2;

   l0:tgenl0;
   l1:array [0..l0max,0..l0max]of byte;//4x4 1=16
   l2:tgenl2;
   l3:array [0..l3max,0..l3max]of byte;//16x16 1=4
   l4:array [0..l4max,0..l4max]of byte;//32x32 1=2
   l5:array [0..l5max,0..l5max]of byte;//64x64 1=1
end;
type TSprGenerator=class
   water,beach,land:array of Tbitmaps;
   wcount,bcount,lcount:integer;
   temp,tmpout:Tbitmaps;
   genmask:tgenmask;
   pass:byte;
   loaded:boolean;
   colorID,colorQTY:array of word;
   colorcount:integer;
   mpalette:TDPalette;
   constructor create;
   destructor destroy;override;
   procedure load(maxbmp:Tbitmaps);overload;
   procedure load(srcb:TSRCBitmap);overload;
   procedure saveSpriteToStream(strm:PStream;inout:byte=1);
   function getgeneratorbitmap(num:smallint=1):Pbitmap;
   procedure getSprColors(whereto:PControl);
   procedure setSprColors(from:PControl);
   procedure changeColor(id:byte;mode: byte=0;ColpalID:byte=0);
   procedure GenerateSpriteWithNumber(num:integer;color:byte;background:byte);
   procedure GenerateTechnoDemoMapForSprite(id:integer;percTo:Pcontrol=nil);
   procedure drawMask(Pbox:Pcontrol;level:byte=0);
   procedure generatesprite(tolevel:byte=7;fromlevel:byte=0);
   procedure randomizespr;
   procedure removecolors(fromBmp:TBitmaps);
   procedure generatespriteEX;
   private
   procedure calcsprcolors;
end;
var Generator:TSprGenerator;
implementation
uses BMGMaxMap,MapGeneratorMain,BMaxGMapGenerator;
{ TSprGenerator }

procedure TSprGenerator.calcsprcolors;
var f2,f3,f4,f6,f5:integer;
var c:byte;
var ok:boolean;
begin
     setlength(colorID,0);
     setlength(colorQTY,0);
     colorcount:=-1;
     for f2:=0 to 63 do
      for f3:=0 to 63 do begin
         f6:=-1;
         c:=temp.data[f2,f3];
         for f5:=0 to colorcount do begin
            if colorID[f5]=c then begin f6:=f5;colorQTY[f5]:=colorQTY[f5]+1;end;
         end;
         if f6=-1 then begin
           inc(colorcount);
           setlength(colorID,colorcount+1);setlength(colorQTY,colorcount+1);
           colorID[colorcount]:=c;colorQTY[colorcount]:=1;
         end;
      end;
      // 
      colorcount:=high(colorID);
      repeat
      ok:=true;
      for f2:=0 to colorcount-1 do begin
         if colorID[f2]>colorID[f2+1] then begin
            f4:=colorID[f2];colorId[f2]:=colorId[f2+1];colorId[f2+1]:=f4;
            f4:=colorQTY[f2];colorQTY[f2]:=colorQTY[f2+1];colorQTY[f2+1]:=f4;
            ok:=false;
         end;
      end;
      until ok;
end;

procedure TSprGenerator.changeColor(id: byte; mode: byte;
  ColpalID: byte);
var f1,f2:integer;
var c:byte;
begin
if mode=0 then c:=colorID[id] else c:=id;
//if id<0 then exit;
for f1:=0 to 63 do
 for f2:=0 to 63 do
  if temp.data[f1,f2]=c then temp.data[f1,f2]:=ColpalID;
end;

constructor TSprGenerator.create;
var f1,f2:integer;
begin
for f1:=0 to l0max do for f2:=0 to l0max do genmask.l0[f1,f2]:=1;
loaded:=false;
colorID:=nil;colorQTY:=nil;
water:=nil;wcount:=-1;
beach:=nil;bcount:=-1;
land:=nil;lcount:=-1;
end;

destructor TSprGenerator.destroy;
begin
loaded:=false;
setlength(colorID,0);colorID:=nil;
setlength(colorQTY,0);colorQTY:=nil;
  setlength(water,0);water:=nil;wcount:=-1;
  setlength(beach,0);beach:=nil;bcount:=-1;
  setlength(land,0);land:=nil;lcount:=-1;
  inherited;
end;

procedure TSprGenerator.drawMask(Pbox: Pcontrol;level:byte);
var f1,f2,w,h,cmn,cmx:integer;
procedure col(colr:byte);begin
        Pbox.Canvas.Brush.Color:=clYellow;
        if colr=0 then Pbox.Canvas.Brush.Color:=clGreen;
        if colr=1 then Pbox.Canvas.Brush.Color:=clAqua;
        if colr=2 then Pbox.Canvas.Brush.Color:=clMaroon;
        if colr=3 then Pbox.Canvas.Brush.Color:=clBlue;
       //    if colr=4 then Pbox.Canvas.Brush.Color:=$10101010;
//           if colr=5 then Pbox.Canvas.Brush.Color:=$20202020;
//           if colr=6 then Pbox.Canvas.Brush.Color:=$30303030;
//           if colr=7 then Pbox.Canvas.Brush.Color:=$40404040;
//           if colr=8 then Pbox.Canvas.Brush.Color:=$50505050;

end;
begin
Pbox.Canvas.Brush.Color:=clAqua;
PBox.Canvas.FillRect(PBox.canvas.ClipRect);
Pbox.Canvas.Pen.Color:=clBlack;
//0- 1- 2- 3-
begin w:=l0max;h:=l0max;cmn:=l0cmin;cmx:=l0cmax;end;
if level=1 then begin w:=l0max;h:=l0max;cmn:=l0cmin;cmx:=l0cmax;end;
if level=2 then begin w:=l2max;h:=l2max;cmn:=l2cmin;cmx:=l2cmax;end;
if level=3 then begin w:=l3max;h:=l3max;cmn:=l3cmin;cmx:=l3cmax;end;
if level=4 then begin w:=l4max;h:=l4max;cmn:=l4cmin;cmx:=l4cmax;end;
if level=5 then begin w:=l5max;h:=l5max;cmn:=l5cmin;cmx:=l5cmax;end;
if level<>0 then begin w:=cmx-cmn;h:=cmx-cmn;end;
inc(cmx);
for f1:=0 to (w) do
   for f2:=0 to (h) do begin
     if level=0 then col(genmask.l0[f1,f2]);
     if level=1 then col(genmask.l1[f1+cmn,f2+cmn]);
     if level=2 then col(genmask.l2[f1+cmn,f2+cmn]);
     if level=3 then col(genmask.l3[f1+cmn,f2+cmn]);
     if level=4 then col(genmask.l4[f1+cmn,f2+cmn]);
     if level=5 then col(genmask.l5[f1+cmn,f2+cmn]);
     Pbox.Canvas.FillRect(makerect(trunc(f1*PBox.Width/(w+1)),trunc(f2*PBox.Height/(h+1)),trunc((f1+1)*PBox.Width/(w+1)),trunc((f2+1)*PBox.Height/(h+1))));
   end;
if (level<>5)and(level<4) then
for f1:=0 to (w) do begin
Pbox.Canvas.Pen.Color:=clBlack;
   if (f1=cmn) or (f1=cmx) then Pbox.Canvas.Pen.Color:=clBlue;
   PBox.Canvas.MoveTo(0,trunc(f1*(PBox.Height-1)/(w+1)));
   Pbox.Canvas.LineTo(PBox.Width,trunc(f1*(PBox.Height-1)/(h+1)));
   PBox.Canvas.MoveTo(trunc(f1*(PBox.Width-1)/(w+1)),0);
   PBox.Canvas.LineTo(trunc(f1*(PBox.Width-1)/(h+1)),PBox.Height);
end;

end;

procedure TSprGenerator.generatesprite(tolevel:byte;fromlevel:byte);
var i,j,w,l:integer;//  ,b
var bout:Tbitmaps;
var bsprites:TBMGSpriteCollection;
function l1change(p1,p2,p3,p4:byte):boolean;
//    1 
//     2   3
//  1  4
var i,j,k,l,c:byte;
begin
   result:=false;
   for i:=1 to l0max-1 do for j:=1 to l0max-1 do
     if genmask.l1[i,j]=p1 then begin
      c:=0;
      for k:=0 to 2 do for l:=0 to 2 do
//         if ((i+k-1)>=0)and((i+k-1)<=l0max)and((j+l-1)>=0)and((j+l-1)<=l0max)then
            if genmask.l1[i+k-1,j+l-1]=p3 then inc(c);
      if p2<=c then genmask.l1[i,j]:=p4;
   end;
end;
function l2change(p1,p2,p3,p4:byte):boolean;
//    1 
//     2   3
//  1  4
var i,j,k,l,c:byte;
var tm:Tgenmask;
begin
   result:=false;tm:=genmask;
   for i:=1 to l2max-1 do for j:=1 to l2max-1 do
     if genmask.l2[i,j]=p1 then begin
      c:=0;
      for k:=0 to 2 do for l:=0 to 2 do
         if genmask.l2[i+k-1,j+l-1]=p3 then inc(c);
      if p2<=c then tm.l2[i,j]:=p4;
   end;
   genmask:=tm;
end;
function l3change(p1,p2,p3,p4:byte):boolean;
//    1 
//     2   3
//  1  4
var i,j,k,l,c:byte;
var tm:Tgenmask;
begin
   result:=false;tm:=genmask;
   for i:=1 to l3max-1 do for j:=1 to l3max-1 do
     if genmask.l3[i,j]=p1 then begin
      c:=0;
      for k:=0 to 2 do for l:=0 to 2 do
         if genmask.l3[i+k-1,j+l-1]=p3 then inc(c);
      if p2<=c then tm.l3[i,j]:=p4;
   end;
   genmask:=tm;
end;
function l4change(p1,p2,p3,p4:byte):boolean;
//    1 
//     2   3
//  1  4
var i,j,k,l,c:byte;
var tm:Tgenmask;
begin
   result:=false;tm:=genmask;
   for i:=1 to l4max-1 do for j:=1 to l4max-1 do
     if genmask.l4[i,j]=p1 then begin
      c:=0;
      for k:=0 to 2 do for l:=0 to 2 do
         if genmask.l4[i+k-1,j+l-1]=p3 then inc(c);
      if p2<=c then tm.l4[i,j]:=p4;
   end;
   genmask:=tm;
end;
function l5change(p1,p2,p3,p4,p5:smallint):boolean;
//    1 
//     2   3
//  1  4
var i,j,k,l,c:byte;
var tm:Tgenmask;
begin
   result:=false;tm:=genmask;
   for i:=1 to l5max-1 do for j:=1 to l5max-1 do
     if genmask.l5[i,j]=p1 then begin
      c:=0;
      for k:=0 to 2 do for l:=0 to 2 do
         if p3>=0 then begin
            if genmask.l5[i+k-1,j+l-1]=p3 then inc(c);
         end else begin
            if genmask.l5[i+k-1,j+l-1]<>abs(p3) then inc(c);
         end;
      if p2<=c then if random(2)=0 then tm.l5[i,j]:=p4 else tm.l5[i,j]:=p5;
   end;
   genmask:=tm;
end;
label l1,l2,l3,l4,l5,l6;
begin
//0- 1- 2- 3-
bsprites:=SpriteBases.current;
if bsprites=nil then bsprites:=SpriteBases.items[0];
randomize;
for i:=0 to 63 do
   for j:=0 to 63 do bout.data[i,j]:=0;
if fromlevel=1 then goto l1;
if fromlevel=2 then goto l2;
if fromlevel=3 then goto l3;
if fromlevel=4 then goto l4;
if fromlevel=5 then goto l5;
if fromlevel=6 then goto l6;

for i:=0 to l0max do for j:=0 to l0max do genmask.l1[i,j]:=genmask.l0[i,j];
l1:;
// 0
l1change(0,5,1,1);//    
//l1change(1,5,0,0);//    
//l1change(2,0,0,0);// 
//l1change(0,1,1,2);// 
// 
w:=0;l:=0;//b:=0;
for i:=l0cmin to l0cmax do
   for j:=l0cmin to l0cmax do begin
      if genmask.l1[i,j]=0 then inc(l);
      if genmask.l1[i,j]=1 then inc(w);
//      if genmask.l1[i,j]=2 then inc(b);
   end;
pass:=2;
if l>=8 then pass:=0;
if w>=8 then pass:=1;
if tolevel<=1 then exit;

//   2
for i:=0 to l0max do for j:=0 to l0max do begin
   genmask.l2[(i*2)+0,(j*2)+0]:=genmask.l1[i,j];genmask.l2[(i*2)+1,(j*2)+0]:=genmask.l1[i,j];
   genmask.l2[(i*2)+0,(j*2)+1]:=genmask.l1[i,j];genmask.l2[(i*2)+1,(j*2)+1]:=genmask.l1[i,j];
end;
if tolevel<=2 then exit;
l2:;
// 1
//l2change(0,5,1,1);//  5=
l2change(1,5,0,0);//    
l2change(0,1,1,1);//  
l2change(0,1,1,2);//  


//l2change(2,5,1,1);//  5=
//l2change(1,5,2,2);//  5=
//l2change(2,5,0,0);//  5=
//l2change(2,5,1,1);//  5=
//l2change(1,5,2,2);//  5=
//l2change(2,5,0,0);//  5=
//l2change(0,5,2,2);//  5=
//   3
for i:=0 to l2max do for j:=0 to l2max do begin
   genmask.l3[(i*2)+0,(j*2)+0]:=genmask.l2[i,j];genmask.l3[(i*2)+1,(j*2)+0]:=genmask.l2[i,j];
   genmask.l3[(i*2)+0,(j*2)+1]:=genmask.l2[i,j];genmask.l3[(i*2)+1,(j*2)+1]:=genmask.l2[i,j];
end;
// 2
l3change(0,5,1,1);//  5=
//l3change(0,2,1,1);//  5=
l3change(0,1,1,1);//  

//l3change(0,1,2,2);// 
//l3change(1,1,2,2);// 


l3change(2,4,1,1);//  5=
l3change(2,4,1,1);//  5=
l3change(1,5,2,2);//  5=
l3change(2,5,0,0);//  5=
l3change(0,5,2,2);//  5=
//l3change(2,3,1,3);//  
//l3change(1,1,2,3);//  
//   4
l3:;
if tolevel<=3 then exit;
for i:=0 to l3max do for j:=0 to l3max do begin
   genmask.l4[(i*2)+0,(j*2)+0]:=genmask.l3[i,j];genmask.l4[(i*2)+1,(j*2)+0]:=genmask.l3[i,j];
   genmask.l4[(i*2)+0,(j*2)+1]:=genmask.l3[i,j];genmask.l4[(i*2)+1,(j*2)+1]:=genmask.l3[i,j];
end;
l4:;
l4change(2,5,1,1);//     1/5
//l4change(2,5,1,1);//     1/5
//l4change(2,5,1,1);//     1/5
l4change(1,5,2,2);//     1/5
l4change(2,5,0,0);//     1/5
l4change(0,5,2,2);//     1/5
//l4change(3,5,1,1);//      1/5
//l4change(2,5,3,3);//      1/5
l4change(2,2,1,1);//  
//l4change(2,2,1,1);//  
//l4change(2,1,1,1);//  

if tolevel<=5 then exit;
//   5
for i:=0 to l4max do for j:=0 to l4max do begin
   genmask.l5[(i*2)+0,(j*2)+0]:=genmask.l4[i,j];genmask.l5[(i*2)+1,(j*2)+0]:=genmask.l4[i,j];
   genmask.l5[(i*2)+0,(j*2)+1]:=genmask.l4[i,j];genmask.l5[(i*2)+1,(j*2)+1]:=genmask.l4[i,j];
end;
l5:;
//l5change(2,1,1,1,1);//  
//l5change(2,1,1,1,1);//  
//l5change(2,1,0,0,0);//  
//l5change(2,1,0,0,0);//  

l5change(0,1,2,0,0);//  
l5change(0,1,2,0,2);//    
l5change(2,1,0,2,0);//    

l5change(2,1,1,2,1);//    
//l5change(2,1,1,2,1);//    

      l5change(1,1,2,2,3);//  
      l5change(1,1,2,3,4);//  

      l5change(1,1,3,4,5);//  
      l5change(1,1,4,5,6);//  

      l5change(1,1,5,6,7);//  
      l5change(1,1,6,7,8);//  

      l5change(1,1,7,8,9);//  
      l5change(1,1,8,9,10);//  

   //   l5change(1,1,4,4,6);//  
  //    l5change(1,1,4,5,5);//  
   //   l5change(1,1,5,5,6);//  

//      l5change(1,2,2,1,5);//  
//      l5change(1,2,3,1,5);//  
//      l5change(1,2,4,1,5);//  

  //    l5change(1,2,3,1,4);//  
//
//if bsprites.BeachItemsCount>=1 then begin
//   for i:=3 to 3+bsprites.BeachItemsCount do begin
//      l5change(1,2,i-1,1,i);//  
//   end;
//end;

//l5change(2,1,3,2,3);//     
//l5change(2,1,3,2,3);//     
//l5change(3,1,1,1,3);//     
// 
if tolevel<=6 then exit;
l6:;
if bsprites.WaterItemsCount>=0 then begin
   load(bsprites.Wateritems[random(bsprites.WaterItemsCount+1)]);
   for i:=0 to 63 do
      for j:=0 to 63 do
         {if genmask.l5[i+2,j+2]=1 then} bout.data[i,j]:=tmpout.data[j,i];
end;
if bsprites.LandItemsCount>=0 then begin
   load(bsprites.landitems[random(bsprites.LandItemsCount+1)]);
   for i:=0 to 63 do
      for j:=0 to 63 do
         if genmask.l5[i+l5cmin,j+l5cmin]=0 then bout.data[i,j]:=tmpout.data[i,j];
end;
if bsprites.BeachItemsCount>=0 then begin
   load(bsprites.Beachitems[0]);
   for i:=0 to 63 do
      for j:=0 to 63 do
         if genmask.l5[i+l5cmin,j+l5cmin]=2 then bout.data[i,j]:=tmpout.data[i,j];
end;
if bsprites.BeachItemsCount>=1 then begin
   for l:=3 to (3+bsprites.BeachItemsCount-1) do begin
      load(bsprites.Beachitems[l-2]);
      for i:=0 to 63 do
         for j:=0 to 63 do
            if genmask.l5[i+l5cmin,j+l5cmin]=l then bout.data[i,j]:=tmpout.data[i,j];

   end;

end;
   for i:=0 to 63 do
      for j:=0 to 63 do
        temp.data[i,j]:=bout.data[j,i];

end;

procedure TSprGenerator.generatespriteEX;
var bsprites:TBMGSpriteCollection;
var bout2:Tbitmaps;
var bout:array[0..127,0..127]of byte;
var bout3:array[0..127,0..127]of byte;
var i,j,k,l,wtr,lnd,bwt:integer;//  ,b  ,bch
procedure change(before, after: byte);
var f1,f2:integer;
begin
for f1:=0 to 127 do
   for f2:=0 to 127 do
      if bout[f1,f2]=before then bout[f1,f2]:=after;
end;
procedure Schange(cur, findqty, find, setto1, setto2: byte);
var f3,f4,f5:byte;
var x,y:smallint;
var f1,f2:integer;

begin
for f1:=0 to 127 do
   for f2:=0 to 127 do begin
     if bout[f1,f2]=cur then begin
      f5:=0;
      for f3:=0 to 2 do for f4:=0 to 2 do begin
         x:=(f1+f3-1);y:=(f2+f4-1);
         if (x>=0)and(x<=127)and(y>=0)and(y<=127)and((x<>1)and(y<>1))then begin
            if bout3[x,y]=find then inc(f5);
         end;
      end;
      if findqty<=f5 then if brandom(2)=1 then bout[f1,f2]:=setto1 else bout[f1,f2]:=setto2;
     end;
   end;
end;
begin
bsprites:=SpriteBases.current;
if bsprites=nil then bsprites:=SpriteBases.items[0];
randomize;wtr:=0;lnd:=0;bwt:=0;//bch:=0;
for i:=0 to 31 do
   for j:=0 to 31 do begin
     for k:=0 to 3 do
      for l:=0 to 3 do
         bout[(i*4)+k,(j*4)+l]:=genmask.mskin2[i,j];
   end;
for i:=0 to 127 do
   for j:=0 to 127 do
      bout3[i,j]:=bout[i,j];
for i:=0 to 15 do
   for j:=0 to 15 do begin
     if genmask.mskin[i,j]=0 then inc(lnd);
     if genmask.mskin[i,j]=1 then inc(wtr);
     if genmask.mskin[i,j]>2 then inc(bwt);
   //  if genmask.mskin[i,j]=2 then inc(bch);
   end;
pass:=2;
if lnd>200 then pass:=0;
if (wtr+bwt)>200 then pass:=1;
   Schange(0,4,2,2,2);//Schange(0,5,2,2,2);
for i:=0 to 127 do for j:=0 to 127 do bout3[i,j]:=bout[i,j];

   Schange(2,4,0,0,0);//Schange(2,5,0,0,0);
for i:=0 to 127 do for j:=0 to 127 do bout3[i,j]:=bout[i,j];
   Schange(2,4,3,3,3);//Schange(2,5,3,3,3);
for i:=0 to 127 do for j:=0 to 127 do bout3[i,j]:=bout[i,j];

   Schange(3,4,2,2,2);//Schange(3,5,2,2,2);
for i:=0 to 127 do for j:=0 to 127 do bout3[i,j]:=bout[i,j];

   Schange(1,4,3,3,3);//Schange(1,5,3,3,3);
for i:=0 to 127 do for j:=0 to 127 do bout3[i,j]:=bout[i,j];
   Schange(3,4,1,1,1);//Schange(3,5,1,1,1);


{   Schange(0,4,2,20,20);change(20,2);

   Schange(2,4,0,20,20);change(20,0);
   Schange(2,4,3,23,23);change(23,3);

   Schange(3,4,2,22,22);change(22,2);
   Schange(3,4,1,21,21);change(21,1);

   Schange(1,4,3,23,23);change(23,3);
 }
//   Schange(2,4,3,12,12);change(12,3);

//Schange(3,1,1,11,11);
//Schange(3,1,11,10,10);
//Schange(3,1,10,9,9);
//Schange(3,1,9,8,8);
//Schange(3,1,8,7,7);
//Schange(3,1,7,6,6);
//Schange(3,1,6,5,5);
//Schange(3,1,5,4,4);
//Schange(11,1,10,11,12);Change(12,10);
//Schange(10,1,9,10,12);Change(12,9);

if bwt>0 then begin
{if bch=0 then begin
   Schange(3,1,1,11,11);
   for i:=11 downto 4 do Schange(3,1,i,i-1,i-1);
   for i:=11 downto 3 do begin Schange(i,1,i-1,i,12);Change(12,i-1);end;
end;
if bch>0 then }begin
   change(3,20);
   for i:=3 to 15 do Schange(20,1,i-1,i,i);
 //  for i:=4 to 11 do change(i,i-1);
   for i:=3 to 11 do begin
      Schange(i,0,i,i,i+1);//Schange(i+1,1,i-1,i+1,i+1);change(15,i);
   end;

//   Schange(4,1,3,12,5);Schange(4,1,12,5,5);change(12,4);
//   for i:=11 to 4 do begin Schange(i,1,i-1,i,12);Change(12,i-1);end;
end;
end;

if bsprites.WaterItemsCount>=0 then begin
   load(bsprites.Wateritems[brandom(bsprites.WaterItemsCount+1)]);
   for i:=0 to 63 do
      for j:=0 to 63 do
         {if genmask.l5[i+2,j+2]=1 then} bout2.data[i,j]:=tmpout.data[j,i];
end;
if bsprites.LandItemsCount>=0 then begin
   load(bsprites.landitems[brandom(bsprites.LandItemsCount+1)]);
   for i:=0 to 63 do
      for j:=0 to 63 do
         if bout[i+32,j+32]=0 then bout2.data[i,j]:=tmpout.data[i,j];
end;
if bsprites.BeachItemsCount>=0 then begin
   load(bsprites.Beachitems[0]);
   for i:=0 to 63 do
      for j:=0 to 63 do
         if bout[i+32,j+32]=2 then bout2.data[i,j]:=tmpout.data[i,j];
end;
if bsprites.BeachItemsCount>=1 then begin
   for l:=3 to (3+bsprites.BeachItemsCount-1) do begin
      load(bsprites.Beachitems[l-2]);
      for i:=0 to 63 do
         for j:=0 to 63 do
            if bout[i+32,j+32]=l then bout2.data[i,j]:=tmpout.data[i,j];

   end;

end;
   for i:=0 to 63 do
      for j:=0 to 63 do
        temp.data[i,j]:=bout2.data[j,i];


end;

procedure TSprGenerator.GenerateSpriteWithNumber(num: integer;color:byte;background:byte);
var bmp:Pbitmap;
var f1,f2:integer;
begin
bmp:=NewBitmap(64,64);
//for f1:=
bmp.Canvas.Brush.Color:=clWhite;
bmp.Canvas.FillRect(bmp.canvas.ClipRect);
f1:=bmp.Canvas.TextWidth(int2str(num));
f2:=bmp.Canvas.TextHeight(int2str(num));
bmp.Canvas.TextOut(32-(f1 div 2),32-(f2 div 2),int2str(num));
for f1:=0 to 63 do
   for f2:=0 to 63 do
     if bmp.Canvas.Pixels[f1,f2]=clWhite then tmpout.data[f2,f1]:=background else tmpout.data[f2,f1]:=color;
tmpout.pass:=0;
bmp.Free;
end;

procedure TSprGenerator.GenerateTechnoDemoMapForSprite(id: integer;percTo:Pcontrol);
var tmp:PmaxMap;
var f1,f2,f3,mx,cr:integer;
var bmp:Pbitmap;
var ss:string;
begin
if percto<>nil then ss:=percto.caption;
tmp:=NewMaxMap;
cr:=0;mx:=259;
tmp.mapsize.x:=112;
tmp.mapsize.y:=112;
tmp.Data.mapsize:=tmp.mapsize.arr;
bmp:=NewBitmap(112,112);
bmp.Canvas.Brush.Color:=clWhite;
bmp.Canvas.FillRect(bmp.canvas.ClipRect);
f1:=bmp.Canvas.TextWidth('TechnoDemo#'+int2str(id));
f2:=bmp.Canvas.TextHeight('TechnoDemo#'+int2str(id));
bmp.Canvas.Font.FontStyle:=[fsBold];
bmp.Canvas.Font.FontHeight:=30;
bmp.Canvas.TextOut(66-(f1 div 2),66-(f2 div 2),'TechnoDemo#'+int2str(id));
for f1:=0 to 111 do
   for f2:=0 to 111 do
     if bmp.Canvas.Pixels[f1,f2]=clWhite then tmp.data.minimap[f2,f1]:=207 else temp.data[f2,f1]:=103;
bmp.Free;

for f1:=0 to 111 do
   for f2:=0 to 111 do
      tmp.Data.map[f1,f2].idword:=207;
//tmp.addMapItem(temp);
f1:=0;f2:=0;
for f3:=0 to 255 do begin
   GenerateSpriteWithNumber(f3,207,f3);
   tmp.addMapItem(tmpout);
   tmp.Data.map[f2,f1].idword:=f3;
   inc(f1);if f1>111 then begin f1:=0;inc(f2);end;
   inc(cr);if percto<>nil then begin percto.caption:=int2str(trunc((cr/mx)*100))+' %';applet.ProcessMessages;end;

end;
//temp:=maxmap.data.bitmaps[id];
//calcsprcolors;
//dothis('DeleteWaterFromGenerator');
for f1:=0 to 63 do
   for f2:=0 to 63 do begin
//      GenerateSpriteWithNumber(tmpout[f1,f2],207,tmpout[f1,f2]);
      tmp.Data.map[f1+10,f2+10].idword:=temp.data[f1,f2];
   end;
   tmp.addMapItem(temp);
for f1:=0 to 63 do begin
   tmp.Data.map[f1+9,9].idword:=256;
end;

//for f1:=0 to 63 do
//   for f2:=0 to 63 do begin
//      GenerateSpriteWithNumber(tmpout[f1,f2],207,tmpout[f1,f2]);
//      tmp.Data.map[f1+65,f2+10].idword:=temp.data[f1,f2];
//   end;

tmp.Data.Mpalette:=maxmap.Data.Mpalette;
tmp.saveMaxFile(getstartdir,'DemoMap'+int2str(id));
free_and_nil(tmp);
if percto<>nil then percto.caption:=ss;
end;

function TSprGenerator.getgeneratorbitmap(num: smallint): Pbitmap;
var stream:Pstream;
begin
result:=nil;
if loaded then begin
randomizespr;
result:=NewBitmap(64,64);
stream:=NewMemoryStream;
saveSpriteToStream(stream,num);
stream.Position:=0;
result.LoadFromStream(stream);
stream.Free;
end;
end;

procedure TSprGenerator.getSprColors(whereto: PControl);
var f2:word;
begin
whereto.Clear;
if loaded=false then exit;
   calcsprcolors;
   // 
   while whereto.LVColCount<1 do whereto.LVColAdd('',taLeft,200);
   for f2:=0 to colorcount do begin
       whereto.LVItemAdd(' '+int2str(colorID[f2])+' - '+int2str(colorQTY[f2])+' ');
   end;
end;

procedure TSprGenerator.load(maxbmp: Tbitmaps);
begin
temp:=maxbmp;
tmpout:=maxbmp;
loaded:=true;
end;

procedure TSprGenerator.load(srcb: TSRCBitmap);
var f1:integer;
begin
if srcb.kind=1 then load(srcb.Bitmap);
if srcb.kind=2 then begin
   colorcount:=srcb.colcount;
   setlength(colorID,colorcount+1);
   setlength(colorQTY,colorcount+1);
   for f1:=0 to colorcount do begin
      colorID[f1]:=srcb.colID[f1];
      colorQTY[f1]:=srcb.colQTY[f1];
   end;
   randomizespr;
end;
end;

procedure TSprGenerator.randomizespr;
var f1,f2,f3,f5:integer;
begin
     colorcount:=high(colorID);
     if colorcount<=0 then exit;
     //,    
     f3:=colorQTY[1];
     f5:=1;
     for f2:=1 to colorCount do
        if (f3<colorQTY[f2])and(colorID[F2]<>0) then begin f3:=colorQTY[f2];f5:=f2;end;
     //     
     for f1:=0 to 63 do
      for f2:=0 to 63 do
       tmpOUT.data[f1,f2]:=colorID[f5];
     //      
     for f1:=0 to colorCount do
      if (colorID[f1]<>0)and(f1<>f5) then
      for f2:=0 to trunc((colorQTY[f1]/f3)*1096) do
       tmpOUT.data[random(64),random(64)]:=colorID[f1];
end;

procedure TSprGenerator.removecolors(fromBmp: TBitmaps);
var f1,f2,f3:integer;
begin
calcsprcolors;
for f1:=0 to 63 do
   for f2:=0 to 63 do
      for f3:=0 to colorcount do
         if colorID[f3]=fromBMP.data[f1,f2] then colorQTY[f3]:=50000;
for f3:=0 to colorcount do
   if colorQTY[f3]=50000 then changecolor(f3);
calcsprcolors;
end;

procedure TSprGenerator.saveSpriteToStream(strm: PStream;inout:byte);
var  bh:bmHeader;
var i1,i2:byte;
var ln:array[0..63]of byte;
begin
strm.Position:=0;
bh.f.Typf:=ord('B')+(ord('M')*256);
bh.f.Res1:=0;
bh.f.Res2:=0;
bh.f.OfBm:=1078;
bh.i.Size:=40;
bh.i.Plan:=1;
bh.i.BitC:=8;
bh.i.Comp:=0;
bh.f.Size:=(64*64)+1078;
bh.i.Widt:=64;
bh.i.Heig:=64;
bh.i.SizI:=64*64;
bh.i.XppM:=0;
bh.i.YppM:=0;
bh.i.NCoL:=256;
bh.i.NCoI:=256;
bh.p:=Mpalette;
//for i1:=0 to 255 do begin        //----+-
//   bh.p[i1][0]:=data.Mpalette[i1].rbg.rgbRed;//,3];//112233
//   bh.p[i1][1]:=data.Mpalette[i1].rbg.rgbGreen;//,2];//231321
//   bh.p[i1][2]:=data.Mpalette[i1].rbg.rgbBlue;//,1];//323112
//   bh.p[i1][0]:=data.Mpalette[i1,3];//112233
//   bh.p[i1][1]:=data.Mpalette[i1,2];//231321
//   bh.p[i1][2]:=data.Mpalette[i1,1];//323112
//end;
strm.Write(bh.f.Typf,2);
strm.Write(bh.f.Size,4);
strm.Write(bh.f.Res1,2);
strm.Write(bh.f.Res2,2);
strm.Write(bh.f.OfBm,4);
strm.Write(bh.i.Size,4);
strm.Write(bh.i.Widt,4);
strm.Write(bh.i.Heig,4);
strm.Write(bh.i.Plan,2);
strm.Write(bh.i.BitC,2);
strm.Write(bh.i.Comp,4);
strm.Write(bh.i.SizI,4);
strm.Write(bh.i.XppM,4);
strm.Write(bh.i.YppM,4);
strm.Write(bh.i.NCoL,4);
strm.Write(bh.i.NCoI,4);
strm.Write(bh.p,1024);
if inout=1 then begin
for i1:=0 to 63 do begin
   for i2:=0 to 63 do ln[i2]:=tmpout.data[63-i1,i2];
   strm.Write(ln,64);
end;
end;
if inout=2 then begin
for i1:=0 to 63 do begin
   for i2:=0 to 63 do ln[i2]:=temp.data[63-i1,i2];
   strm.Write(ln,64);
end;
end;

end;

procedure TSprGenerator.setSprColors(from: PControl);
var f1,f2:word;
begin
if loaded=false then exit;
   for f2:=0 to from.LVCount-1 do begin
      for f1:=0 to colorcount do begin
         
      end;
//       whereto.LVItemAdd(' '+int2str(colorID[f2])+' - '+int2str(colorQTY[f2])+' ');
   end;
end;

initialization
Generator:=nil;
finalization
if Generator<>nil then Generator.Free;
generator:=nil;
end.
