unit BMaxGGame;

interface
uses windows,kol,Main,BMGMaxMap,BMaxGTypes,BMaxGPlayer,BMaxGGameMap, BMaxGDraw,BMaxGObject;
type PNewGame=^TNewGame;
   TNewGame=object(TObj)
   map:PMaxMap;
   gamemap:Pgamemap;
   MDraw:PBmaxDraw;
   gamefilename:string;
   mapfile:string;
   plcount:byte;
   startgold:integer;
   sectors:byte;
   landsectors:array of TStartSector;
   landsectorscount:integer;
   moraturn:integer;
   mnmpsctrs:Pbitmap;
   Allunit:PUnits;
   players:array of PNewPlayer;
   playerscount:integer;
   CurPlayer:PNewPlayer;
   Procedure LoadMap(path:Pcontrol;preview:Pcontrol);
   procedure show(Pgamefilename,Pmapfile,Pplcount,Pstartgold,Psectors,Pmoraturn,PsectorsCnt:PControl);
   procedure Get(Pgamefilename,Pmapfile,Pplcount,Pstartgold,Psectors,Pmoraturn,PsectorsCnt:PControl);
   destructor destroy;virtual;
   procedure SaveToFile;
   procedure Reload;
   function LoadFromFile(Filename:string):boolean;
   procedure getStartConditionstoMemo(Memo:PControl);
   procedure getPlayersConditionstoListView(LV:PControl);
   procedure drawMinimap(PaintBox:PControl;sectrs:boolean);
   procedure loadPlayer(byName:string);
   Procedure AddPlayer(NewPlayer:PNewPlayer);
   procedure prepareToUnloadPlayer;
   function player(Id:byte):PNewPlayer;
end;
Function CreatePNewGame:PNewGame;
function playerCondition2string(i:integer;eng:boolean=false):string;
implementation
uses BmaxGPrg;
function playerCondition2string(i:integer;eng:boolean):string;
begin
result:='?';
case i of
0: result:=' ';
1: result:=' ';
2: result:='  ';
3: result:='';
end;
if eng then begin
case i of
0: result:='Not Landed';
1: result:='You Turn NOW';
2: result:='Wait for others players';
3: result:='Eliminated';
end;
end;
end;
Function CreatePNewGame:PNewGame;
begin
   new(result,create);
   Glsr[IDGame]:=result;
   result.map:=nil;
   result.allunit:=NewUnits;
   result.sectors:=10;
   result.mnmpsctrs:=nil;
   result.landsectorscount:=-1;
   result.landsectors:=nil;
   result.players:=nil;
   result.playerscount:=-1;
   result.CurPlayer:=nil;
end;

destructor TNewGame.destroy;
var f1:integer;
begin
   if MDraw<>nil then begin MDraw.Free;MDraw:=nil;end;
   if allunit<>nil then allunit.free;
   CurPlayer:=nil;
   if gamemap<>nil then free_and_nil(gamemap);
   if map<>nil then free_and_nil(map);
   free_and_nil(mnmpsctrs);
   landsectorscount:=-1;
   setlength(landsectors,0);
   landsectors:=nil;
   for f1:=0 to high(players) do begin
      if players[f1]<>nil then players[f1].Free;
      players[f1]:=nil;
   end;
   setlength(players,0);
   players:=nil;
   playerscount:=-1;
   inherited;
end;

procedure TNewGame.Get(Pgamefilename, Pmapfile, Pplcount, Pstartgold,
  Psectors, Pmoraturn,PsectorsCnt: PControl);
begin
  gamefilename:=Pgamefilename.Text;
  mapfile:=ExtractFileName(Pmapfile.text);
  plcount:=str2int(wrt(Pplcount.Text));
  startgold:=str2int(wrt(Pstartgold.Text));
  if Psectors.checked then sectors:=str2int(wrt(PsectorsCnt.caption)) else sectors:=0;
  moraturn:=str2int(wrt(Pmoraturn.Text));

end;

procedure TNewGame.LoadMap(path, preview: Pcontrol);
var b:Pbitmap;
begin
   main.Form1.OpenSaveDialog1.InitialDir:=getstartdir;
   main.Form1.OpenSaveDialog1.Filter:='MAX map files *.wrl|*.wrl';
   if main.Form1.OpenSaveDialog1.Execute then begin
      path.Text:=main.Form1.OpenSaveDialog1.Filename;
      if map=nil then map:=newMaxMap;
      map.loadMaxFile(ExtractFilePath(path.Text),ExtractFileName(path.Text));
      if map.loaded = false then begin path.Text:='';ShowMessage('Strange file... it''s not M.A.X map file i think'+#13#10+'  .     M.A.X');exit;end
      else begin
         b:=map.getMinimapBitmap;
         b.StretchDraw(preview.canvas.Handle,preview.canvas.ClipRect);
         b.Free;
      end;

   end;
end;

function TNewGame.LoadFromFile(Filename: string):boolean;
var PF:Pstream;
var b,f2:byte;
var s:string;
var f1:integer;
begin
result:=false;
pf:=NewReadFileStream(filename);
  s:=pf.ReadStrZ;
  if s<>'MaxGoldSaveFile' then begin showmessage('This is not MAX Gold by Barloggg savegame file'+#13#10+'   ');exit;end;
  gamefilename:=pf.ReadStrZ;
  mapfile:=pf.ReadStrZ;
  pf.Read(plcount,sizeof(plcount));
  pf.Read(startgold,sizeof(startgold));
  pf.Read(sectors,sizeof(sectors));
  pf.Read(moraturn,sizeof(moraturn));
  pf.Read(landsectorscount,sizeof(landsectorscount));
  setlength(landsectors,landsectorscount+1);
  for f1:=0 to landsectorscount do begin
     pf.Read(landsectors[f1].x,1);
     pf.Read(landsectors[f1].y,1);
     pf.Read(landsectors[f1].player,1);
  end;
  pf.Read(b,1);
  if b<>1 then begin
     if map<>nil then map.Free;
     map:=NewMaxMap;
     pf.Read(map.Data.map2,sizeof(map.Data.map2));
  end;
  if Fileexists(getstartdir+mapfile) then map.loadMaxFile(getstartdir,mapfile) else begin
     showmessage('Map file not found. Please select where map file '+mapfile+'located'+#13#10+'  '+mapfile+'  .   ');
     main.Form1.OpenSaveDialog1.Filter:='MAX map files *.wrl|*.wrl';
     main.Form1.OpenSaveDialog1.InitialDir:=getstartdir;
     if main.Form1.OpenSaveDialog1.Execute=false then exit;
     map.loadMaxFile('',main.Form1.OpenSaveDialog1.Filename);
     if b=1 then map.Data.map2:=map.Data.map;
  end;
  repeat
  f2:=0;
  if not(equal(map.Data.map,map.Data.map2)) then f2:=1;
  if f2=1 then begin
     showmessage('Wrong Map file. Please find correct map file for map '+mapfile+#13#10+' -    .    '+mapfile);
     main.Form1.OpenSaveDialog1.Filter:='MAX map files *.wrl|*.wrl';
     main.Form1.OpenSaveDialog1.InitialDir:=getstartdir;
     if main.Form1.OpenSaveDialog1.Execute=false then exit;
     map.loadMaxFile('',main.Form1.OpenSaveDialog1.Filename);
  end;
  until f2=0;
  allunit.loadfromstream(pf);
  pf.Read(playerscount,sizeof(playerscount));
  setlength(players,playerscount+1);
  for f1:=0 to playerscount do begin
     pf.Read(b,1);
     if b=1 then begin
        players[f1]:=CreatePNewPlayer;
        players[f1].loadfromstream(pf);
        players[f1].Game:=prg.Game;
     end;
   end;
  pf.Free;
  result:=true;
end;

procedure TNewGame.SaveToFile;
var PF:Pstream;
var b:byte;
var f1:integer;
var s:string;
begin
pf:=NewMemorystream;
  s:='MaxGoldSaveFile';
  pf.WriteStrZ(s);
  pf.WriteStrZ(gamefilename);
  pf.WriteStrZ(mapfile);
  pf.Write(plcount,sizeof(plcount));
  pf.Write(startgold,sizeof(startgold));
  pf.Write(sectors,sizeof(sectors));
  pf.Write(moraturn,sizeof(moraturn));
  pf.Write(landsectorscount,sizeof(landsectorscount));
  for f1:=0 to landsectorscount do begin
     pf.Write(landsectors[f1].x,1);
     pf.Write(landsectors[f1].y,1);
     pf.Write(landsectors[f1].player,1);
  end;
  b:=1;
  if map.loaded=false then pf.Write(b,1) else begin
     b:=0;pf.Write(b,1);
     map.SaveToStream(map.Data.map,pf);
  end;
  allunit.save2stream(pf);
  playerscount:=high(players);
  pf.Write(playerscount,sizeof(playerscount));
  for f1:=0 to playerscount do begin
    b:=0;
    if players[f1]=nil then pf.Write(b,1) else begin
       b:=1;pf.Write(b,1);players[f1].savetostream(pf);
    end;
  end;
  pf.SaveToFile(getstartdir+gamefilename+'.sav',0,pf.Position);
pf.Free;
end;

procedure TNewGame.show(Pgamefilename, Pmapfile, Pplcount, Pstartgold, Psectors,
  Pmoraturn,PsectorsCnt: PControl);
begin
  Pgamefilename.Text:=gamefilename;
  Pmapfile.text:=mapfile;
  Pplcount.Text:=int2str(plcount);
  Pstartgold.Text:=int2str(startgold);
  Psectors.checked:=(sectors>0);
  Pmoraturn.Text:=int2str(moraturn);
  PsectorsCnt.Text:=int2str(sectors);
end;

procedure TNewGame.getStartConditionstoMemo(Memo: PControl);
begin
memo.Clear;
memo.Text:=' :';
if sectors>0 then memo.Text:=memo.Text+#13#10+' . '+int2str(sectors)+'x'+int2str(sectors)+'='+int2str(sectors*sectors)+'   .';
memo.Text:=memo.Text+#13#10+'  '+int2str(startgold);
memo.Text:=memo.Text+#13#10+'  '+map.MapFilename;

end;

procedure TNewGame.drawMinimap(PaintBox: PControl; sectrs: boolean);
var sc:single;
var f1:integer;
var Cnv:PCanvas;
var tr:Trect;
begin
if sectrs then begin
   if mnmpsctrs=nil then begin mnmpsctrs:=NewBitmap(paintbox.Width,paintbox.Height);end;
   Cnv:=mnmpsctrs.Canvas;
   map.getMinimapBitmap.StretchDraw(Cnv.Handle,Cnv.ClipRect);
   sc:=(paintbox.Width-1) / sectors;
   landsectorscount:=high(landsectors);
   for f1:=0 to landsectorscount do begin
      if landsectors[f1].player<>254 then begin
         tr:=makerect(trunc(landsectors[f1].x*sc),trunc(landsectors[f1].y*sc),trunc((landsectors[f1].x+1)*sc),trunc((landsectors[f1].y+1)*sc));
         if landsectors[f1].player=255 then cnv.Brush.Color:=prg.newplayer.info.color else
                                            cnv.Brush.Color:=players[landsectors[f1].player].info.color;
         cnv.FillRect(tr);
      end;
   end;
   Cnv.Pen.Color:=clGray div 2;
   for f1:=0 to sectors do begin
      Cnv.MoveTo(trunc(f1*sc),0);Cnv.LineTo(trunc(f1*sc),mnmpsctrs.width);
      Cnv.MoveTo(0,trunc(f1*sc));Cnv.LineTo(mnmpsctrs.width,trunc(f1*sc));
   end;
   mnmpsctrs.StretchDraw(Paintbox.Canvas.Handle,paintbox.ClientRect);
end else map.getMinimapBitmap.StretchDraw(Paintbox.Canvas.Handle,paintbox.ClientRect);
end;

procedure TNewGame.AddPlayer(NewPlayer: PNewPlayer);
var f1,f2:integer;
begin
playerscount:=high(players)+1;
f2:=-1;
for f1:=0 to playerscount-1 do begin
   if players[f1]<>nil then if players[f1].playerID>f2 then f2:=players[f1].playerID;
end;
f2:=f2+1;
setlength(Players,playerscount+1);
players[playerscount]:=NewPlayer;
players[playerscount].playerID:=f2;
players[playerscount].Game:=prg.Game;
landsectorscount:=high(landsectors);
for f1:=0 to landsectorscount do if landsectors[f1].player=255 then landsectors[f1].player:=playerscount;
savetofile;
end;

procedure TNewGame.getPlayersConditionstoListView(LV: PControl);
var row,colcnt:integer;
var f1:integer;
procedure incc;
begin
   inc(row);
   if LV.LVCount<(row+1) then LV.LVItemAdd('');
end;
begin
colcnt:=2;row:=0;
while LV.LVCount<(row+1) do LV.LVItemAdd('');
while LV.LVColCount<=(colcnt) do LV.LVColAdd('',taLeft,0);
for f1:=0 to playerscount do begin
   if players[f1]<>nil then begin
      LV.LVItems[row,0]:=players[f1].info.name;
      LV.LVItems[row,1]:=int2str(players[f1].info.turnscount);
      LV.LVItems[row,2]:=playerCondition2string(players[f1].info.condition);
      incc;
   end;
end;
end;

procedure TNewGame.loadPlayer(byName: string);
var f1:integer;
begin
curplayer:=nil;
for f1:=0 to playerscount do begin
   if players[f1]<>nil then begin
      if players[f1].info.name=byName then begin
         if players[f1].info.condition=3 then begin
            showmessage(' '+byname+' .    .'+#13#10+'Player '+byname+' eliminated. His turn never come');
            exit;
         end;
         if players[f1].info.condition=2 then begin
            showmessage('        .   .'+#13#10+'Others players not done their turns yet. You need to wait');;
            exit;
         end;
         curplayer:=players[f1];
         Glsr[IDCurplayer]:=curplayer;
         exit;
      end;
   end;
end;
showmessage(' '''+byName+'''  '+#13#10+'Player '''+byName+''' not found');
end;

procedure TNewGame.prepareToUnloadPlayer;
begin
   if gamemap=nil then gamemap:=NewGameMap;
   Glsr[IDGamemap]:=gamemap;
   gamemap.setmaxmap(map);
   if MDraw=nil then MDraw:=NewMaxDraw;
   mdraw.nodrawnow:=true;
   CurPlayer.upgradelevel.prepareUnitIcons;
   mdraw.nodrawnow:=false;

   MDraw.setmaxmap(map);
   gamemap.useSectors(landsectors,landsectorscount,curplayer.playerid,sectors);
   Mdraw.showsectors:=(landsectorscount>0);
   Mdraw.Cellw:=0;free_and_nil(Mdraw.outscreen);
   mdraw.pos.x:=map.mapsize.x div 2;
   mdraw.pos.y:=map.mapsize.y div 2;
end;

procedure TNewGame.Reload;
begin
LoadFromFile(getstartdir+gamefilename+'.sav');

end;

function TNewGame.player(Id: byte): PNewPlayer;
var f1:integer;
begin
result:=nil;
for f1:=0 to playerscount do begin
   if players[f1]<>nil then
     if players[f1].playerID=Id then begin
        result:=Players[f1];
        exit;
     end;
end;
end;

end.
