unit BMaxGMapGenerator;

interface
uses kol,BMaxGTypes,BMGSpritegenerator,BMGSpriteCollection;
type tstrp=record
   pos:TXY;
   length:array of TXY;
end;
type idXY=record
   pos:TXY;
   id:word;
end;
type tstripes=record
   startpos:TXY;
   length:array of tstrp;

end;
type Tislands=record
   pos:TXY;
   r:array[0..360]of byte;
end;
type genmapitem=record
   msk:tgenIN;
   msk2:tgenIN2;
   spr:Tbitmaps;
   pass:byte;
end;
type PMapGenerator=^TMapGenerator;
   TMapGenerator=object(TObj)
   tileset:TBMGSpriteCollection;
   placedobtacles:array of idXY;
   placedobtaclescount:integer;
   stripes:array of Tstripes;slengthmax,SLength,Swidth:integer;scount,scur:integer;
   billiard:array of txy;bSize:word;bCount,bCur:integer;
   islands:array of Tislands;iSize:word;iCount,iCur:integer;
   Ilislands,IlLakes:array of Tislands;iLiSize,iLlsize:word;ilICount,iLLCount,iliCur,iLLCur:integer;

   SwCur:integer;
   chSize:integer;
   mapsize,rmapsize,hqmapsize:TmapSizeEx;
   mpalette:TDPalette;
   gmask:tgenl0;
   gmaskl2:tgenl2;
   preview:PBitmap;
   rseed:integer;
   mapitems:array of genmapitem;
   mapitemsQTY:array of integer;
   mapitemscount:integer;
   handpos:array of TXY;
   handmp:array of byte;
   hcount:integer;
   mapdata:array of array of byte;
   HQmapdata:array of array of byte;
   readymapdata:array of array of word;
   readyminimap:array of array of byte;
   mask:array of array of byte;
   placeobtacles:boolean;
   ObtaclesOnCorner:boolean;
   ObtaclesOnLand:boolean;
   ObtaclesCount:word;
   LowQuality:boolean;
   ULowQuality:boolean;
   HQuality:boolean;
   flatbeach:boolean;   
   stop,usepreset,flatminimap:boolean;

   destructor destroy;virtual;
   procedure generatepreviewdata;
   procedure generatepreview(ml:byte=1);
   procedure compilemap(fromscratch:boolean=true;percto:PControl=nil);
   procedure savetomaxmap;
   procedure saveBMGFile(dir,fname:string);
   procedure LoadBMGFile(dir,fname:string);
   function getpreviewbitmap:Pbitmap;
   function getreadyminimapbitmap:Pbitmap;
   procedure addhand(x,y:integer;mb:byte);
   private
   procedure placeobtacle(pos:Txy;radius:word;obID:integer=-1;checkfor:boolean=true);
   procedure placeland(pos:txy;radius:word;invert:boolean=false;ml:byte=1);
   procedure placesqrland(pos:txy;size:word;invert:boolean=false;ml:byte=1);
   procedure placeIsland(island:tislands;radius:word;invert:boolean=false;ml:byte=1);
   procedure savePrewiveBitmaptostream(strm: PStream;ml:byte=1);
   procedure saveReadyMinimaptostream(strm: PStream);
   function itemID(msk:tgenIN):integer;
   function addmapitem(msk:tgenIN;msk2:tgenIN2):integer;overload;
   function addmapitem(bm:TBitmaps):word;overload;
   procedure mapchange(before,after,ml:byte);overload;
   procedure mapchange(cur,findqty,find,setto1,setto2,ml:byte);overload;
end;
function NewMapGenerator:PMapGenerator;
var rpos:integer;
var rmax:integer;
var mapgen:PMapGenerator;
{$i BmaxRndData.pas}
function brandom(nummax:integer):integer;
function brandomize:integer;
implementation
uses MapGeneratorMain;
function brandomize:integer;
begin
randomize;
rpos:=random(rmax-1)+1;
result:=rpos;
end;
function brandom(nummax:integer):integer;
begin
result:=trunc(nummax*rnddata[rpos]/10000);
inc(rpos);if rpos>rmax then rpos:=1;
end;
function NewMapGenerator:PMapGenerator;
begin
   new(result,create);
   setlength(result.placedobtacles,0);
   result.placedobtaclescount:=-1;
   setlength(result.mapitems,0); setlength(result.mapitemsQTY,0);
   setlength(result.readymapdata,0,0);
   setlength(result.readyminimap,0,0);
   result.mapitemscount:=-1;
   setlength(result.stripes,0);
   result.preview:=nil;
   result.tileset:=nil;
   result.flatminimap:=false;
   result.flatbeach:=false;
   result.LowQuality:=false;
   result.ULowQuality:=false;
   setlength(result.handpos,0);
   setlength(result.handmp,0);
   result.hcount:=-1;
   result.stop:=false;
   result.usepreset:=false;
end;

procedure TMapGenerator.addhand(x, y: integer; mb: byte);
begin
inc(hcount);
setlength(handpos,hcount+1);
setlength(handmp,hcount+1);
handpos[hcount]:=XY(x div 2,y div 2);
handmp[hcount]:=mb;
end;

function TMapGenerator.addmapitem(msk:tgenIN;msk2:tgenIN2):integer;

begin
inc(mapitemscount);
setlength(mapitems,mapitemscount+1);
setlength(mapitemsQTY,mapitemscount+1);
mapitemsQTY[mapitemscount]:=0;
mapitems[mapitemscount].msk:=msk;
mapitems[mapitemscount].msk2:=msk2;

generator.genmask.mskin:=msk;
generator.genmask.mskin2:=msk2;
generator.generatespriteEX;
mapitems[mapitemscount].spr:=generator.temp;
mapitems[mapitemscount].pass:=generator.pass;

result:=mapitemscount;
end;

function TMapGenerator.addmapitem(bm: TBitmaps):word;
var f1,f2,f3,f4:integer;
begin
for f1:=0 to mapitemscount do begin
   f4:=0;
   for f2:=0 to 63 do
      for f3:=0 to 63 do begin
         if mapitems[f1].spr.data[f2,f3]<>bm.data[f2,f3] then f4:=1;
      end;
   if mapitems[f1].pass<>bm.pass then f4:=1;
   if f4=0 then begin
      result:=f1;exit;
   end;
end;
inc(mapitemscount);
setlength(mapitems,mapitemscount+1);
setlength(mapitemsQTY,mapitemscount+1);
mapitemsQTY[mapitemscount]:=0;
for f1:=0 to 15 do
   for f2:=0 to 15 do
     mapitems[mapitemscount].msk[f1,f2]:=5;
mapitems[mapitemscount].spr:=bm;
mapitems[mapitemscount].pass:=bm.pass;
result:=mapitemscount;
end;

procedure TMapGenerator.compilemap(fromscratch:boolean=true;percto:PControl=nil);
var f1,f2,f3,f4,f5,dt,cur,max,ml:integer;
var cllr:array[0..4]of byte;
var tmp:TgenIN;
    tmp2:tgenIN2;
var osb:TBMGSpriteCollection;
procedure rndmapitems(f,t:word);
var i,j:integer;
begin
for i:=0 to mapsize.x-1 do
   for j:=0 to mapsize.y-1 do
      if readymapdata[i,j]=f then
        if random(2)=1 then readymapdata[i,j]:=t;
end;
begin

rpos:=rseed;
ml:=16;
generatepreview(ml);
dt:=0;
osb:=nil;
if fromscratch then begin
   setlength(placedobtacles,0);
   placedobtaclescount:=-1;
   setlength(mapitems,0);
   setlength(mapitemsQTY,0);
   mapitemscount:=-1;
end;
if tileset=nil then begin dt:=1;
   if SpriteBases=nil then exit;
   if SpriteBases.current=nil then exit;
   tileset:=SpriteBases.current;
end else begin
   osb:=SpriteBases.current;
   SpriteBases.current:=tileset;
end;
generator.mpalette:=tileset.Mpalette;
mpalette:=tileset.Mpalette;
if tileset.LandItemsCount>=0 then begin
   f1:=0;
   if tileset.LandItems[f1].kind=1 then cllr[0]:=tileset.LandItems[f1].Bitmap.data[32,32];
   if tileset.LandItems[f1].kind=2 then cllr[0]:=tileset.LandItems[f1].colID[1];
end;
if tileset.WaterItemsCount>=0 then begin
   f1:=0;
   if tileset.WaterItems[f1].kind=1 then cllr[1]:=tileset.WaterItems[f1].Bitmap.data[32,32];
   if tileset.WaterItems[f1].kind=2 then cllr[1]:=tileset.WaterItems[f1].colID[1];
end;
if tileset.BeachItemsCount>=0 then begin
   if tileset.BeachItems[0].kind=1 then cllr[2]:=tileset.BeachItems[0].Bitmap.data[32,32];
   if tileset.BeachItems[0].kind=2 then cllr[2]:=tileset.BeachItems[0].colID[1];
end else cllr[2]:=cllr[0];
if tileset.BeachItemsCount>=1 then begin
   if tileset.BeachItems[1].kind=1 then cllr[3]:=tileset.BeachItems[2].Bitmap.data[32,32];
   if tileset.BeachItems[1].kind=2 then cllr[3]:=tileset.BeachItems[2].colID[1];
end else cllr[3]:=cllr[1];
max:=mapsize.x;cur:=0;

if fromscratch then begin
setlength(readymapdata,mapsize.x,mapsize.y);
setlength(readyminimap,mapsize.x,mapsize.y);
if percto<>nil then begin
   PercTO.caption:='Preparing...';
   applet.processmessages;
end;
mapchange(0,5,1,1,1,ml);mapchange(0,4,1,6,6,ml);mapchange(6,1,ml);
mapchange(0,1,1,2,2,ml);mapchange(0,3,2,5,5,ml);mapchange(5,2,ml);
mapchange(1,1,2,3,3,ml);
mapchange(1,1,3,4,4,ml);mapchange(4,3,ml);

for f1:=1 to mapsize.x do begin
   for f2:=1 to mapsize.y do begin
         for f3:=0 to 15 do
         for f4:=0 to 15 do
            tmp[f3,f4]:=mapdata[(f1*ml)+f3,(f2*ml)+f4];
       if stop then begin
          if dt=1 then tileset:=nil else spritebases.current:=osb;
          generatepreview;exit;end;
       f5:=itemID(tmp);
       if f5=-1 then begin
         for f3:=0 to 31 do
         for f4:=0 to 31 do
            tmp2[f3,f4]:=mapdata[(f1*ml)+f3-8,(f2*ml)+f4-8];
         f5:=addmapitem(tmp,tmp2);
       end;
      readymapdata[f2-1,f1-1]:=f5;
      readyminimap[f2-1,f1-1]:=cllr[mapitems[f5].pass];
   end;
inc(cur);if percto<>nil then begin
   PercTO.caption:='Map '+int2str(trunc((cur/max)*100))+' %';
   applet.processmessages;
end;
end;

if (Ulowquality=false)then begin
f3:=0;
if Lowquality=false then f3:=2;
if Hquality then f3:=4;
for f4:=0 to f3 do begin
f2:=mapitemscount;
for f1:=0 to f2 do begin
   if mapitemsqty[f1]>20 then begin
      f5:=addmapitem(mapitems[f1].msk,mapitems[f1].msk2);
      rndmapitems(f1,f5);
   end;
   mapitemsqty[f1]:=0;
end;
for f1:=0 to mapsize.x-1 do
   for f2:=0 to mapsize.y-1 do
     inc(mapitemsQty[readymapdata[f1,f2]]);
end;
end;
max:=0;cur:=0;
if ObtaclesOnCorner then begin inc(max,mapsize.x);inc(max,mapsize.y);end;
if ObtaclesOnLand then inc(max,ObtaclesCount);

if placeobtacles then begin
   if ObtaclesOnCorner then begin
      for f1:=0 to mapsize.x-1 do begin
          if mapitems[readymapdata[f1,0]].pass=0 then begin
             if brandom(3)<>1 then placeobtacle(xy(f1,0),10);
          end;
          if mapitems[readymapdata[f1,mapsize.y-1]].pass=0 then begin
             if brandom(3)<>1 then placeobtacle(xy(f1,mapsize.y-1),10);
          end;
inc(cur);if percto<>nil then begin
   PercTO.caption:='Beach 100% Obtacles '+int2str(trunc((cur/max)*100))+' %';
   applet.processmessages;
end;
      end;
      for f1:=0 to mapsize.y-1 do begin
          if mapitems[readymapdata[0,f1]].pass=0 then begin
             if brandom(3)<>1 then placeobtacle(xy(0,f1),10);
          end;
          if mapitems[readymapdata[mapsize.x-1,f1]].pass=0 then begin
             if brandom(3)<>1 then placeobtacle(xy(mapsize.x-1,f1),10);
          end;
inc(cur);if percto<>nil then begin
   PercTO.caption:='Beach 100% Obtacles '+int2str(trunc((cur/max)*100))+' %';
   applet.processmessages;
end;
      end;
   end;
   if ObtaclesOnLand then begin;
   for f1:=0 to ObtaclesCount do begin
         f3:=brandom(mapsize.x);
         f2:=brandom(mapsize.y);
         placeobtacle(xy(f3,f2),10);
inc(cur);if percto<>nil then begin
   PercTO.caption:='Beach 100% Obtacles '+int2str(trunc((cur/max)*100))+' %';
   applet.processmessages;
end;
      end;
   end;
end;
if flatminimap=false then begin
for f1:=0 to mapsize.x-1 do
   for f2:=0 to mapsize.y-1 do
      readyminimap[f1,f2]:=mapitems[readymapdata[f1,f2]].spr.data[32,32];
end;
end;
if fromscratch=false then begin
   for f1:=0 to mapitemscount do begin
      generator.genmask.mskin:=mapitems[f1].msk;
      generator.generatesprite;

      mapitems[f1].spr:=generator.temp;
   end;
   for f1:=0 to placedobtaclescount do begin
      placeobtacle(placedobtacles[f1].pos,10,placedobtacles[f1].id,false);
   end;
end;
if dt=1 then tileset:=nil else spritebases.current:=osb;
generatepreview;
end;

destructor TMapGenerator.destroy;
 var f1,f2:integer;
begin
   if tileset<>nil then tileset.free;
   tileset:=nil;
   setlength(placedobtacles,0);
   placedobtaclescount:=-1;

   setlength(readymapdata,0,0);
   setlength(readyminimap,0,0);
   setlength(mapitems,0); setlength(mapitemsQTY,0);
   mapitemscount:=-1;
   setlength(handpos,0);
   setlength(handmp,0);
   hcount:=-1;
for f1:=0 to high(stripes)do begin
   for f2:=0 to high(stripes[f1].length) do
      setlength(stripes[f1].length[f2].length,0);
   setlength(stripes[f1].length,0);
   stripes[f1].length:=nil;

end;
setlength(stripes,0);
stripes:=nil;
setlength(billiard,0);
setlength(islands,0);
setlength(Ilislands,0);
setlength(IlLakes,0);

if preview<>nil then preview.Free;
preview:=nil
end;

procedure TMapGenerator.generatepreview(ml:byte=1);
var f1,f2,F3,i,j:integer;
var r:single;
var b1,b2:byte;
begin
SCur:=Form1.scrollbar6.SBPosition;
SLength:=Form1.scrollbar7.SBPosition;
if preview<>nil then preview.Free;preview:=nil;
setlength(mapdata,(rmapsize.x*ml)+1,(rmapsize.y*ml)+1);
for f1:=0 to (rmapsize.x*ml) do
   for f2:=0 to (rmapsize.y*ml) do
      mapdata[f1,f2]:=1;
rpos:=rseed;

if form1.radiobox23.checked then begin
   SwCur:=Form1.scrollbar16.SBPosition;
for f1:=0 to (((rmapsize.x*ml)-1)div 2) do
   for f2:=0 to (((rmapsize.y*ml)-1)div 2) do begin
      f3:=brandom(10);
      for i:=0 to 1 do
         for j:=0 to 1 do begin
      if f3<swcur then mapdata[(f1*2)+i,(f2*2)+j]:=1;
      if f3>swcur then mapdata[(f1*2)+i,(f2*2)+j]:=0;
      if f3=swcur then mapdata[(f1*2)+i,(f2*2)+j]:=2;
      end;
   end;
   SwCur:=Form1.scrollbar17.SBPosition;
for f1:=0 to (SwCur*ml) do
   for f2:=0 to (SwCur*ml) do begin
      mapdata[f1+((rmapsize.x*ml) div 10),f2+((rmapsize.y*ml) div 10)]:=0;
      mapdata[(rmapsize.x*ml)-f1-((rmapsize.x*ml) div 10),(rmapsize.y*ml)-f2-((rmapsize.y*ml) div 10)]:=0;
      mapdata[f1+((rmapsize.x*ml) div 10),(rmapsize.y*ml)-f2-((rmapsize.y*ml) div 10)]:=0;
      mapdata[(rmapsize.x*ml)-f1-((rmapsize.x*ml) div 10),f2+((rmapsize.y*ml) div 10)]:=0;
   end;
flatbeach:=false;
end;

if form1.radiobox22.checked then begin
   chSize:=Form1.scrollbar15.SBPosition;
   i:=trunc((rmapsize.x*ml) / chsize)div 2;
   j:=trunc((rmapsize.y*ml) / chsize)div 2;
   b1:=0;
   for f1:=0 to i do begin
      if b1=0 then b1:=1 else b1:=0;
      b2:=b1;
      for f2:=0 to j do begin
         if b2=0 then b2:=1 else b2:=0;
         if b2=0 then placesqrland(xy(((rmapsize.x*ml)div 2)+(f1*chSize*ml),((rmapsize.y*ml)div 2)+(f2*chSize*ml)),chSize*ml,false,ml);
         if b2=0 then placesqrland(xy(((rmapsize.x*ml)div 2)-(chSize*ml)-(f1*chSize*ml),((rmapsize.y*ml)div 2)-(chSize*ml)-(f2*chSize*ml)),chSize*ml,false,ml);
      end;
   end;
   b1:=1;
   for f1:=0 to i do begin
      if b1=0 then b1:=1 else b1:=0;
      b2:=b1;
      for f2:=0 to j do begin
         if b2=0 then b2:=1 else b2:=0;
         if b2=0 then placesqrland(xy(((rmapsize.x*ml)div 2)-(chSize*ml)-(f1*chSize*ml),((rmapsize.y*ml)div 2)+(f2*chSize*ml)),chSize*ml,false,ml);
         if b2=0 then placesqrland(xy(((rmapsize.x*ml)div 2)+(f1*chSize*ml),((rmapsize.y*ml)div 2)-(chSize*ml)-(f2*chSize*ml)),chSize*ml,false,ml);
      end;
   end;
end;

if form1.radiobox21.checked then begin
setlength(mask,(ml*2)+1,(ml*2)+1);
for i:=0 to ml do
  for j:=0 to ml do begin
     if ((i*i)+(j*j))<=(ml*ml) then f3:=0 else f3:=1;
     mask[ml-i,ml-j]:=f3;mask[i+ml,ml-j]:=f3;
     mask[ml-i,ml+j]:=f3;mask[i+ml,ml+j]:=f3;
end;
   iLISize:=Form1.scrollbar11.SBPosition;
   iLICur:=Form1.scrollbar12.SBPosition;
   for f1:=0 to ilICur do
      placeIsland(Ilislands[f1],iLIsize,false,ml);
   iLLSize:=Form1.scrollbar13.SBPosition;
   iLLCur:=Form1.scrollbar14.SBPosition;
   for f1:=0 to ilLCur do
      placeIsland(IlLakes[f1],iLLsize,true,ml);
end;

if form1.radiobox19.checked then begin
setlength(mask,(ml*2)+1,(ml*2)+1);
for i:=0 to ml do
  for j:=0 to ml do begin
     if ((i*i)+(j*j))<=(ml*ml) then f3:=0 else f3:=1;
     mask[ml-i,ml-j]:=f3;mask[i+ml,ml-j]:=f3;
     mask[ml-i,ml+j]:=f3;mask[i+ml,ml+j]:=f3;
end;
   iSize:=Form1.scrollbar9.SBPosition;
   iCur:=Form1.scrollbar10.SBPosition;
   for f1:=0 to iCur do
      placeIsland(islands[f1],isize,false,ml);
end;

if form1.radiobox20.checked then begin
flatbeach:=false;
SWidth:=Form1.scrollbar4.SBPosition*ml;
BSize:=Form1.scrollbar4.SBPosition*ml;
BCur:=Form1.scrollbar5.SBPosition;
r:=(bCur*(rmapsize.x*ml)/10);
setlength(mask,(SWidth*2)+1,(SWidth*2)+1);
for i:=0 to SWidth do
  for j:=0 to SWidth do begin
     if ((i*i)+(j*j))<=(SWidth*SWidth) then f3:=0 else f3:=1;
     mask[SWidth-i,SWidth-j]:=f3;mask[i+SWidth,SWidth-j]:=f3;
     mask[SWidth-i,SWidth+j]:=f3;mask[i+SWidth,SWidth+j]:=f3;
end;
for f1:=0 to BCur do begin
i:=((rmapsize.x*ml)div 2)+trunc(Billiard[f1].x*bSize/5);
j:=((rmapsize.y*ml)div 2)+trunc(Billiard[f1].y*bSize/5);
if (i>=Bsize)and(j>=Bsize)and(i<=(rmapsize.x*ml)-Bsize)and(j<=(rmapsize.y*ml)-Bsize) then
    placeland(xy(i,j),Swidth,false,ml);
end;
end;

if form1.radiobox18.checked then begin
SWidth:=Form1.scrollbar8.SBPosition*ml;
setlength(mask,(SWidth*2)+1,(SWidth*2)+1);
for i:=0 to SWidth do
  for j:=0 to SWidth do begin
     if ((i*i)+(j*j))<=(SWidth*SWidth) then f3:=0 else f3:=1;
     mask[SWidth-i,SWidth-j]:=f3;mask[i+SWidth,SWidth-j]:=f3;
     mask[SWidth-i,SWidth+j]:=f3;mask[i+SWidth,SWidth+j]:=f3;
end;
for f1:=0 to SCur do begin
   for f2:=0 to SLength do begin
      placeland(xy(Stripes[f1].length[f2].pos.x*ml,Stripes[f1].length[f2].pos.y*ml),Swidth,false,ml);
   end;
end;
Swidth:=6;
setlength(mask,(SWidth*2)+1,(SWidth*2)+1);
for i:=0 to SWidth do
  for j:=0 to SWidth do begin
     if ((i*i)+(j*j))<=(SWidth*SWidth) then f3:=0 else f3:=1;
     mask[SWidth-i,SWidth-j]:=f3;mask[i+SWidth,SWidth-j]:=f3;
     mask[SWidth-i,SWidth+j]:=f3;mask[i+SWidth,SWidth+j]:=f3;
end;
for f1:=0 to SCur do begin
   for f2:=0 to SLength do begin
      for f3:=0 to high(Stripes[f1].length[f2].length) do begin
         if f3<=Form1.scrollbar8.SBPosition then
      placeland(xy(Stripes[f1].length[f2].pos.x*ml,Stripes[f1].length[f2].pos.y*ml),Swidth,false,ml);

      end;
   end;
end;
end;

if flatbeach then begin
for f1:=1 to (rmapsize.x*ml)-1 do
   for f2:=1 to (rmapsize.y*ml)-1 do begin
      f3:=0;
      if mapdata[f1,f2]=1 then begin
         for i:=-1 to 1 do
         for j:=-1 to 1 do begin
            if mapdata[f1+i,f2+j]=0 then inc(f3);
         end;
         if f3>0 then begin
           if brandom(6)=0 then begin
              for i:=-1 to 1 do
              for j:=-1 to 1 do begin
                 mapdata[f1+i,f2+j]:=6;
              end;
           end;
         end;
      end;
end;
for f1:=1 to (rmapsize.x*ml)-1 do
   for f2:=1 to (rmapsize.y*ml)-1 do begin
      if mapdata[f1,f2]=6 then mapdata[f1,f2]:=0;
end;
end;

if form1.radiobox3.checked then begin
   for f1:=0 to ((rmapsize.x*ml) div 2) do
      for f2:=0 to (rmapsize.y*ml) do
         mapdata[rmapsize.x-f1,f2]:=mapdata[f1,f2];
end;
if form1.radiobox4.checked then begin
   for f1:=0 to (rmapsize.x*ml) do
      for f2:=0 to ((rmapsize.y*ml) div 2) do
         mapdata[f1,(rmapsize.y*ml)-f2]:=mapdata[f1,f2];
end;
if form1.radiobox5.checked then begin
   if mapsize.X<>mapsize.Y then begin
      showmessage('Diagonal mirror can be useb only on square maps'+#13#10+
                  '      ');
      form1.radiobox13.checked:=true;
      exit;
   end;
   for f1:=0 to (rmapsize.x*ml) do
      for f2:=0 to f1 do
         mapdata[f1,f2]:=mapdata[f2,f1];
end;
if form1.radiobox6.checked then begin
   if mapsize.X<>mapsize.Y then begin
      showmessage('Diagonal mirror can be useb only on square maps'+#13#10+
                  '      ');
      form1.radiobox13.checked:=true;
      exit;
   end;
   for f1:=0 to (rmapsize.x*ml) do
      for f2:=0 to f1 do
         mapdata[(rmapsize.x*ml)-f1,f2]:=mapdata[(rmapsize.x*ml)-f2,f1];
end;
if form1.radiobox11.checked then begin
   if mapsize.X<>mapsize.Y then begin
      showmessage('Diagonal mirror can be useb only on square maps'+#13#10+
                  '      ');
      form1.radiobox13.checked:=true;
      exit;
   end;
   for f1:=0 to (rmapsize.x*ml) do
      for f2:=0 to f1 do
         mapdata[f1,f2]:=mapdata[f2,f1];
   for f1:=0 to ((rmapsize.x*ml) div 2) do
      for f2:=0 to ((rmapsize.y*ml) div 2) do begin
         mapdata[(rmapsize.x*ml)-f1,f2]:=mapdata[f1,f2];
         mapdata[f1,(rmapsize.y*ml)-f2]:=mapdata[f1,f2];
         mapdata[(rmapsize.x*ml)-f1,(rmapsize.y*ml)-f2]:=mapdata[f1,f2];
   end;
end;
if form1.radiobox12.checked then begin
   if mapsize.X<>mapsize.Y then begin
      showmessage('Diagonal mirror can be useb only on square maps'+#13#10+
                  '      ');
      form1.radiobox13.checked:=true;
      exit;
   end;
   for f1:=0 to (rmapsize.x*ml) do
      for f2:=0 to f1 do
         mapdata[(rmapsize.x*ml)-f1,f2]:=mapdata[(rmapsize.x*ml)-f2,f1];
   for f1:=0 to ((rmapsize.x*ml) div 2) do
      for f2:=0 to ((rmapsize.y*ml) div 2) do begin
         mapdata[f1,f2]:=mapdata[(rmapsize.x*ml)-f1,f2];
         mapdata[f1,(rmapsize.y*ml)-f2]:=mapdata[(rmapsize.x*ml)-f1,f2];
         mapdata[(rmapsize.x*ml)-f1,(rmapsize.y*ml)-f2]:=mapdata[(rmapsize.x*ml)-f1,f2];
   end;
end;

if form1.CheckBox3.checked then begin
SWidth:=2*ml;
setlength(mask,(SWidth*2)+1,(SWidth*2)+1);
for i:=0 to SWidth do
  for j:=0 to SWidth do begin
     if ((i*i)+(j*j))<=(SWidth*SWidth) then f3:=0 else f3:=1;
     mask[SWidth-i,SWidth-j]:=f3;mask[i+SWidth,SWidth-j]:=f3;
     mask[SWidth-i,SWidth+j]:=f3;mask[i+SWidth,SWidth+j]:=f3;
end;
for f1:=0 to hcount do begin
    placeland(xy(handpos[f1].X*ml,handpos[f1].Y*ml),Swidth,handmp[f1]=1,ml);
end;
end;
if lowquality then begin
   for f1:=0 to ((rmapsize.x*ml) div 2)-1 do
   for f2:=0 to ((rmapsize.y*ml) div 2)-1 do begin
      for i:=0 to 1 do
         for j:=0 to 1 do
            mapdata[(f1*2)+i,(f2*2)+j]:=mapdata[f1*2,f2*2];
   end;
end;
if Ulowquality then begin
   for f1:=0 to ((rmapsize.x*ml) div 4)-1 do
   for f2:=0 to ((rmapsize.y*ml) div 4)-1 do begin
      for i:=0 to 3 do
         for j:=0 to 3 do
            mapdata[(f1*4)+i,(f2*4)+j]:=mapdata[f1*4,f2*4];
   end;
end;
end;

procedure TMapGenerator.generatepreviewdata;
var f1,f2,dx,dy,n,ddx,ddy:integer; 
var stps:TXY;
var ok:boolean;
var a:single;
begin
if usepreset=false then rseed:=brandomize;

scount:=Form1.scrollbar6.SBMax;
setlength(stripes,scount+1);
SLengthMax:=Form1.scrollbar7.SBMax;
SLength:=Form1.scrollbar7.SBPosition;
SWidth:=Form1.scrollbar8.SBMax;
mapsize.x:=str2int(wrt(form1.editbox17.Text));
mapsize.y:=str2int(wrt(form1.editbox18.Text));
rmapsize.x:=(mapsize.x+2);
rmapsize.y:=(mapsize.y+2);

n:=0;
stps:=xy(brandom(rmapsize.X+1),brandom(rmapsize.Y+1));
for f1:=0 to scount do begin  inc(n);
if n>10 then begin n:=0;stps:=xy(brandom(rmapsize.X+1),brandom(rmapsize.Y+1));
end;
   stripes[f1].startpos:=stps;
   setlength(stripes[f1].length,SlengthMAX+1);

   Stripes[f1].length[0].pos:=XY(stripes[f1].startpos.X+brandom(5)-3,stripes[f1].startpos.Y+brandom(5)-3);
      dx:=brandom(7)-3;
      dy:=brandom(7)-3;
   for f2:=1 to SlengthMAX do begin
      dx:=dx+brandom(3)-1;if dx>5 then dx:=5;if dx<-5 then dx:=-5;
      dy:=dy+brandom(3)-1;if dy>5 then dy:=5;if dy<-5 then dy:=-5;
      Stripes[f1].length[f2].pos:=XY(stripes[f1].length[f2-1].pos.X+dx,stripes[f1].length[f2-1].pos.Y+dy);

      setlength(Stripes[f1].length[f2].length,1);
      ddx:=brandom(7)-3;
      ddy:=brandom(7)-3;
      Stripes[f1].length[f2].length[0]:=XY(Stripes[f1].length[f2].pos.x+ddx,Stripes[f1].length[f2].pos.y+ddy);
   end;
end;

rpos:=rseed;

ilICount:=Form1.scrollbar12.SBMax;
ilLCount:=Form1.scrollbar14.SBMax;
setlength(iLislands, ilICount+1);
setlength(iLlakes, ilLCount+1);
dx:=100;
for f1:=0 to ilIcount do begin
iLislands[f1].pos:=XY(brandom(rmapsize.x+1),brandom(rmapsize.y+1));
for f2:=0 to 360 do begin
   dx:=dx+brandom(5)-2;
   if dx<10 then dx:=10;if dx>100 then dx:=100;
   iLislands[f1].r[f2]:=dx;
end;
end;
dx:=100;
for f1:=0 to ilLcount do begin
iLlakes[f1].pos:=XY(brandom(rmapsize.x+1),brandom(rmapsize.y+1));
for f2:=0 to 360 do begin
   dx:=dx+brandom(5)-2;
   if dx<10 then dx:=10;if dx>100 then dx:=100;
   iLlakes[f1].r[f2]:=dx;
end;
end;

rpos:=rseed;

iCount:=Form1.scrollbar10.SBMax;
setlength(islands, iCount+1);
dx:=100;
for f1:=0 to icount do begin
islands[f1].pos:=XY(brandom(rmapsize.x+1),brandom(rmapsize.y+1));
for f2:=0 to 360 do begin
   dx:=dx+brandom(5)-2;
   if dx<10 then dx:=10;if dx>100 then dx:=100;
   islands[f1].r[f2]:=dx;
end;
end;

rpos:=rseed;

BCount:=Form1.scrollbar5.SBMax;
setlength(billiard, bCount+1);
Bcur:=1;
billiard[0]:=xy(0,0);
f1:=2;
a:=0;
repeat
ok:=false;
a:=a+(5*pi/180);
if a>(2*pi) then begin a:=a-(2*pi);f1:=f1+2;end;
dx:=trunc(sin(a)*f1);dy:=trunc(cos(a)*f1);
ddx:=0;
for f2:=0 to Bcur-1 do begin
   if sqrt(((dx-billiard[f2].x)*(dx-billiard[f2].x))+((dy-billiard[f2].y)*(dy-billiard[f2].y)))<10 then ddx:=1;
end;
if ddx=0 then begin
   billiard[Bcur]:=xy(dx,dy);inc(Bcur);
end;
if Bcur>=Bcount then ok:=true;
until ok;
for f1:=1 to BCount do begin
   stps:=billiard[f1];
   f2:=brandom(Bcount)+1;
   billiard[f1]:=billiard[f2];billiard[f2]:=stps;
end;
generatepreview;
end;
function TMapGenerator.getpreviewbitmap: Pbitmap;
var stream:Pstream;
begin
if preview=nil then preview:=NewBitmap(mapsize.x,mapsize.Y);
stream:=NewMemoryStream;
savePrewiveBitmaptostream(stream);
stream.Position:=0;
preview.LoadFromStream(stream);
stream.Free;
result:=preview;
end;

function TMapGenerator.getreadyminimapbitmap: Pbitmap;
var stream:Pstream;
begin
if preview<>nil then preview.Free;
preview:=NewBitmap(mapsize.x,mapsize.Y);
stream:=NewMemoryStream;
saveReadyMinimaptostream(stream);
stream.Position:=0;
preview.LoadFromStream(stream);
stream.Free;
result:=preview;
end;

procedure TMapGenerator.LoadBMGFile(dir, fname: string);
var f:Pstream;
var f1,f2:integer;
begin
   f:=NewReadFileStream(dir+fname);
   f.Read(mapitemscount,sizeof(mapitemscount));
   setlength(mapitems,mapitemscount+1);
   for f1:=0 to mapitemscount do begin
      f.Read(mapitems[f1].msk,sizeof(mapitems[f1].msk));
      f.Read(mapitems[f1].pass,sizeof(mapitems[f1].pass));
   end;
   f.Read(mapsize.x,sizeof(mapsize.x));
   f.Read(mapsize.y,sizeof(mapsize.y));
   setlength(readymapdata,mapsize.x+1,mapsize.y+1);
   setlength(readyminimap,mapsize.x+1,mapsize.y+1);
   for f1:=0 to mapsize.x-1 do
      for f2:=0 to mapsize.y-1 do begin
         f.Read(readymapdata[f1,f2],2);
         f.Read(readyminimap[f1,f2],1);
      end;
   f.Read(placedobtaclescount,sizeof(placedobtaclescount));
   setlength(placedobtacles,placedobtaclescount+1);
   for f1:=0 to placedobtaclescount do begin
      placedobtacles[f1].pos:=Stream2XY(f);
      f.Read(placedobtacles[f1].ID,sizeof(placedobtacles[f1].ID));
   end;
   if tileset<>nil then tileset.free;
      tileset:=TBMGSpriteCollection.create;
      tileset.loadfromstream(f);
   mpalette:=tileset.Mpalette;
   f.free;
   end;

procedure TMapGenerator.placeland(pos: txy; radius: word;invert:boolean;ml:byte);
var f1,f2,f3:integer;
begin
for f1:=pos.x-radius to pos.x+radius do
   for f2:=pos.Y-radius to pos.y+radius do begin
      if f1>=0 then
      if f2>=0 then
      if f1<=(rmapsize.X*ml) then
      if f2<=(rmapsize.Y*ml) then begin
         if mapdata[f1,f2]=1 then begin
            mapdata[f1,f2]:=mask[f1-pos.x+radius,f2-pos.Y+radius];
         end;
         if (invert) then begin
            f3:=mask[f1-pos.x+radius,f2-pos.Y+radius];
            if f3=0 then begin f3:=1;
            mapdata[f1,f2]:=f3;end;
         end;
      end;
end;
end;

procedure TMapGenerator.placeobtacle(pos: Txy; radius: word;
  obID: integer;checkfor:boolean);
var f1,f2,f3,x,y,ok,rcur,i,j:integer;
begin
if tileset=nil then exit;
if tileset.Obtaclescount<0 then exit;
if obID=-1 then obID:=random(tileset.obtaclescount+1);
for rcur:=0 to radius do begin
for f1:=pos.x-rcur to pos.x+rcur do
   for f2:=pos.y-rcur to pos.y+rcur do begin
      ok:=0;
      for f3:=0 to tileset.Obtacles[obID].itemcount do begin
         x:=f1+tileset.Obtacles[obID].itempos[f3].Y;
         y:=f2+tileset.Obtacles[obID].itempos[f3].X;
         if (ok=0)and(x>=0)and(y>=0)and(x<mapsize.x)and(y<mapsize.y)then begin
            if mapitems[readymapdata[x,y]].pass<>0 then ok:=1;
            for i:=l2cmin to l2cmax do
              for j:=l2cmin to l2cmax do
                if mapitems[readymapdata[x,y]].msk[i,j]<>0 then ok:=1;
         end else begin
            if f3=1 then ok:=1;
         end;
      end;
      if checkfor=false then ok:=0;
      if ok=0 then begin
         for f3:=0 to tileset.Obtacles[obID].itemcount do begin
            x:=f1+tileset.Obtacles[obID].itempos[f3].Y;
            y:=f2+tileset.Obtacles[obID].itempos[f3].X;
            if (x>=0)and(y>=0)and(x<mapsize.x)and(y<mapsize.y)then begin
               if checkfor=false then begin
                   mapitems[readymapdata[x,y]].spr:=tileset.Obtacles[obID].items[f3];
                   mapitems[readymapdata[x,y]].pass:=tileset.Obtacles[obID].items[f3].pass;
               end else begin
                   readymapdata[x,y]:=addmapitem(tileset.Obtacles[obID].items[f3]);
               end;
            end;
         end;
   inc(placedobtaclescount);
   setlength(placedobtacles,placedobtaclescount+1);
   placedobtacles[placedobtaclescount].pos:=xy(f1,f2);
   placedobtacles[placedobtaclescount].id:=obID;
         exit;
      end;
   end;
end;
end;

procedure TMapGenerator.placeIsland(island:tislands; radius: word;
  invert: boolean;ml:byte);
var f1,f2,dx,dy:integer; 
var a:single;
begin

for f1:=0 to 360 do begin
a:=(f1*pi/180);

for f2:=0 to trunc(island.r[f1]*radius/100) do begin
   dx:=(island.pos.x*ml)+trunc(sin(a)*f2*ml);
   dy:=(island.pos.y*ml)+trunc(cos(a)*f2*ml);
   placeland(xy(dx,dy),ml,invert,ml)

end;
end;
end;

procedure TMapGenerator.saveBMGFile(dir, fname: string);
var f:Pstream;
var f1,f2:integer;
begin
   f:=NewMemoryStream;
   f.Write(mapitemscount,sizeof(mapitemscount));
   for f1:=0 to mapitemscount do begin
      f.Write(mapitems[f1].msk,sizeof(mapitems[f1].msk));
      f.Write(mapitems[f1].pass,sizeof(mapitems[f1].pass));
   end;
   f.Write(mapsize.x,sizeof(mapsize.x));
   f.Write(mapsize.y,sizeof(mapsize.y));
   for f1:=0 to mapsize.x-1 do
      for f2:=0 to mapsize.y-1 do begin
         f.Write(readymapdata[f1,f2],2);
         f.Write(readyminimap[f1,f2],1);
      end;
   f.Write(placedobtaclescount,sizeof(placedobtaclescount));
   for f1:=0 to placedobtaclescount do begin
      XY2Stream(placedobtacles[f1].pos,f);
      f.Write(placedobtacles[f1].ID,sizeof(placedobtacles[f1].ID));
   end;
   if tileset=nil then begin
      spritebases.current.savetostream(f);
   end else begin
      tileset.savetostream(f);
   end;
   f.SaveToFile(dir+fname+'.bmg',0,f.Position);
   f.free;
end;

procedure TMapGenerator.savePrewiveBitmaptostream(strm: PStream;ml:byte);
var w,h,f1,f2,f3:integer;
var bh:bmHeader;
var csh:array [0..249]of byte;
var cshpz:byte;
var cllr:array[0..4]of byte;
begin
w:=mapsize.x * ml;h:=mapsize.Y * ml;
if SpriteBases=nil then exit;
if SpriteBases.current=nil then exit;
if SpriteBases.current.LandItemsCount>=0 then begin
   f1:=0;
   if SpriteBases.current.LandItems[f1].kind=1 then cllr[0]:=SpriteBases.current.LandItems[f1].Bitmap.data[32,32];
   if SpriteBases.current.LandItems[f1].kind=2 then cllr[0]:=SpriteBases.current.LandItems[f1].colID[1];
end;
if SpriteBases.current.WaterItemsCount>=0 then begin
   f1:=0;
   if SpriteBases.current.WaterItems[f1].kind=1 then cllr[1]:=SpriteBases.current.WaterItems[f1].Bitmap.data[32,32];
   if SpriteBases.current.WaterItems[f1].kind=2 then cllr[1]:=SpriteBases.current.WaterItems[f1].colID[1];
end;
if SpriteBases.current.BeachItemsCount>=0 then begin
   if SpriteBases.current.BeachItems[0].kind=1 then cllr[2]:=SpriteBases.current.BeachItems[0].Bitmap.data[32,32];
   if SpriteBases.current.BeachItems[0].kind=2 then cllr[2]:=SpriteBases.current.BeachItems[0].colID[1];
end else cllr[2]:=cllr[0];
if SpriteBases.current.BeachItemsCount>=1 then begin
   if SpriteBases.current.BeachItems[1].kind=1 then cllr[3]:=SpriteBases.current.BeachItems[1].Bitmap.data[32,32];
   if SpriteBases.current.BeachItems[1].kind=2 then cllr[3]:=SpriteBases.current.BeachItems[1].colID[1];
end else cllr[3]:=cllr[1];

bh.f.Typf:=ord('B')+(ord('M')*256);bh.f.Res1:=0;bh.f.Res2:=0;bh.f.OfBm:=1078;
bh.i.Size:=40;bh.i.Plan:=1;bh.i.BitC:=8;bh.i.Comp:=0;
bh.f.Size:=(w*h*4)+1078;
bh.i.Widt:=w*2;bh.i.Heig:=h*2;
bh.i.SizI:=(w*h*4);
bh.i.XppM:=0;bh.i.YppM:=0;
bh.i.NCoL:=256;bh.i.NCoI:=256;
bh.p:=SpriteBases.current.Mpalette;
strm.Write(bh.f.Typf,2);strm.Write(bh.f.Size,4);strm.Write(bh.f.Res1,2);strm.Write(bh.f.Res2,2);strm.Write(bh.f.OfBm,4);
strm.Write(bh.i.Size,4);strm.Write(bh.i.Widt,4);strm.Write(bh.i.Heig,4);strm.Write(bh.i.Plan,2);strm.Write(bh.i.BitC,2);strm.Write(bh.i.Comp,4);strm.Write(bh.i.SizI,4);strm.Write(bh.i.XppM,4);strm.Write(bh.i.YppM,4);strm.Write(bh.i.NCoL,4);strm.Write(bh.i.NCoI,4);
strm.Write(bh.p,1024);
cshpz:=0;
for f2:=(h) downto 1 do
   for f3:=0 to 1 do
   for f1:=1 to (w) do begin
      csh[cshpz]:=cllr[mapdata[(f1+1),(f2+1)]];inc(cshpz);
      csh[cshpz]:=cllr[mapdata[(f1+1),(f2+1)]];inc(cshpz);
      if cshpz>249 then begin
         cshpz:=0;
         strm.write(csh,250);
      end;
   end;
if cshpz>0 then strm.write(csh,cshpz+1);

end;

procedure TMapGenerator.saveReadyMinimaptostream(strm: PStream);
var w,h,f1,f2:integer;
var bh:bmHeader;
var csh:array [0..249]of byte;
var cshpz:byte;

begin
w:=mapsize.x;h:=mapsize.Y;

bh.f.Typf:=ord('B')+(ord('M')*256);bh.f.Res1:=0;bh.f.Res2:=0;bh.f.OfBm:=1078;
bh.i.Size:=40;bh.i.Plan:=1;bh.i.BitC:=8;bh.i.Comp:=0;
bh.f.Size:=(w*h)+1078;
bh.i.Widt:=w;bh.i.Heig:=h;
bh.i.SizI:=(w*h);
bh.i.XppM:=0;bh.i.YppM:=0;
bh.i.NCoL:=256;bh.i.NCoI:=256;
bh.p:=Mpalette;
strm.Write(bh.f.Typf,2);strm.Write(bh.f.Size,4);strm.Write(bh.f.Res1,2);strm.Write(bh.f.Res2,2);strm.Write(bh.f.OfBm,4);
strm.Write(bh.i.Size,4);strm.Write(bh.i.Widt,4);strm.Write(bh.i.Heig,4);strm.Write(bh.i.Plan,2);strm.Write(bh.i.BitC,2);strm.Write(bh.i.Comp,4);strm.Write(bh.i.SizI,4);strm.Write(bh.i.XppM,4);strm.Write(bh.i.YppM,4);strm.Write(bh.i.NCoL,4);strm.Write(bh.i.NCoI,4);
strm.Write(bh.p,1024);
cshpz:=0;
for f2:=(h-1) downto 0 do
   for f1:=0 to (w-1) do begin
      csh[cshpz]:=readyminimap[f2,f1];inc(cshpz);
      if cshpz>249 then begin
         cshpz:=0;
         strm.write(csh,250);
      end;
   end;
if cshpz>0 then strm.write(csh,cshpz+1);

end;

procedure TMapGenerator.savetomaxmap;
var f1,f2:integer;
begin
for f1:=0 to 111 do
   for f2:=0 to 111 do begin
     maxmap.Data.map[f1,f2].idword:=readymapdata[f1,f2];
     maxmap.map[f2,f1].idword:=readymapdata[f1,f2];
     maxmap.Data.minimap[f1,f2]:=readyminimap[f1,f2];
   end;
maxmap.Data.mapsize:=mapsize.arr;
maxmap.Data.mapitemscount:=mapitemscount+1;
setlength(maxmap.Data.bitmaps,mapitemscount+1);
setlength(maxmap.Data.passtab,mapitemscount+1);
for f1:=0 to mapitemscount do begin
   maxmap.Data.bitmaps[f1]:=mapitems[f1].spr;
   maxmap.Data.passtab[f1]:=mapitems[f1].pass;
end;
maxmap.Data.Mpalette:=Mpalette;
maxmap.loaded:=true;

end;

procedure TMapGenerator.placesqrland(pos: txy; size: word;
  invert: boolean;ml:byte);
var f1,f2,dx,dy:integer;
begin
for f1:=0 to size do
for f2:=0 to size do begin
   dx:=pos.x+f1;
   dy:=pos.y+f2;
   if dx>=0 then
   if dy>=0 then
   if dx<=(rmapsize.X*ml) then
   if dy<=(rmapsize.Y*ml) then begin
      if (invert) then begin if mapdata[dx,dy]=0 then mapdata[dx,dy]:=1 end;
      if (invert=false) then begin if mapdata[dx,dy]=1 then mapdata[dx,dy]:=0;end;
   end;
end;
end;

procedure TMapGenerator.mapchange(before, after,ml: byte);
var f1,f2:integer;
begin
for f1:=0 to (rmapsize.x*ml) do
   for f2:=0 to (rmapsize.y*ml) do
      if mapdata[f1,f2]=before then mapdata[f1,f2]:=after;
end;

procedure TMapGenerator.mapchange(cur, findqty, find, setto1, setto2,
  ml: byte);
var k,l,c:byte;
var f1,f2:integer;
begin
for f1:=1 to (rmapsize.x*ml)-1 do
   for f2:=1 to (rmapsize.y*ml)-1 do begin
     if mapdata[f1,f2]=cur then begin
      c:=0;
      for k:=0 to 2 do for l:=0 to 2 do
            if mapdata[f1+k-1,f2+l-1]=find then inc(c);
      if findqty<=c then if random(2)=1 then mapdata[f1,f2]:=setto1 else mapdata[f1,f2]:=setto2;
   end;
end;
end;

function TMapGenerator.itemID(msk: tgenIN): integer;
var f1,f2,f3,f5:integer;
var ok,ok2:boolean;
begin
result:=-1;
for f1:=0 to mapitemscount do begin
   f5:=0;
   f2:=0;ok:=false;
   repeat
     f3:=0;ok2:=false;
     repeat
        if mapitems[f1].msk[f2,f3]<>msk[f2,f3] then f5:=1;
        inc(f3);
        if f5=1 then ok2:=true;
        if f3>15 then ok2:=true;
     until ok2;
     inc(f2);
     if f5=1 then ok:=true;
     if f2>15 then ok:=true;
   until ok;
   if f5=0 then begin
      inc(mapitemsQTY[f1]);
      result:=f1;exit;
   end;
end;

end;

initialization
mapgen:=nil;
rmax:=13333;
for rpos:=1 to rmax do rnddata[rpos]:=random(10000);
rpos:=1;

end.

