unit BMaxGUnitsInfo;

interface
uses kol, BMaxGTypes,BProcsPack;
type TUnitConstInfo=record
   defOptions:TUoptions;
   ENGname:string;
   name:string;
   Description:string;
   GruzMAX:TMXRES;       
   hasconnector:byte;    

   picnum:byte;           

   size:TMGSize;          

   canmove:TMoveCost;      

   obtacle:TObtacle;      

   buyEnable:FTbuyEnable;
   Draw:TMaxGFunc;

   DefFunc:MaxFuncArray;

   icon,ricon,fwicon:Pbitmap;
   Ficon:FTUnitIcon;
end;
type TDefunitParams=class
   selfID:integer;
   Firepower:byte;
   firesmax:byte;
   Firerange:byte;
   AmmoMax:byte;
   Armor:byte;
   HitsMax:byte;
   ScanRange:byte;
   MoveMax:byte;
   Cost:Smallint;
   function save2stream(strm:Pstream):boolean;
   function loadfromstream(strm:Pstream):boolean;
end;
type TunitParams=class
   locked:byte;
   def:TdefunitParams;
   mk:word;
   Firepower:byte;
   firesmax:byte;
   Firerange:byte;
   AmmoMax:byte;
   Armor:byte;
   HitsMax:byte;
   ScanRange:byte;
   MoveMax:byte;
   Cost:Smallint;
   constructor create;
   destructor destroy;override;
   function save2stream(strm:Pstream):boolean;
   function loadfromstream(strm:Pstream):boolean;
   function Maxparams:Tcurparams;
end;
type PUnitupgradehistory=^TUnitupgradehistory;
   TUnitupgradehistory=object(TObj)
   SelfID:byte;
   def:TDefunitParams;
   info:TUnitConstInfo;
   upg:array of Tunitparams;
   upgcount:integer;
   function Params(mk:integer=-1):Tunitparams;overload;
   function Params(parID:string):integer;overload;
   function Params(parID:string;mode:byte):string;overload;
   procedure Params(ts:PControl;mode:TstringgridfillType);overload;
   procedure load(engname: string; Firepower, firesmax, Firerange,
  AmmoMax, Armor, HitsMax, ScanRange, MoveMax: byte;
  hasconnector: byte; Cost: Smallint;
  GruzMax: TMXRES; obtacle:TObtacle; canmove: TMoveCost;
   Size: TMGSize; name:string;BuyEnable:FTbuyEnable;drawproc:TMaxGFunc;Description: string);overload;
   procedure load(what:string);overload;
   procedure Upgrade(parId:string;var qty,costUP,costDOWN:integer);overload;
   function Upgrade(parId,updown:string;money:integer):integer;overload;
   destructor destroy;virtual;
   function save2stream(strm:PStream):boolean;
   function loadfromstream(strm:Pstream):boolean;
end;
type TUpgradeLevel=class
   UnitsCount:integer;
   Units:array of PUnitupgradehistory;
   function FindBy(UtypeID:integer):PUnitupgradehistory;overload;
   function FindBy(ENGRUSName:string):PUnitupgradehistory;overload;
   function Params(UtypeID:integer;mk:integer=-1):Tunitparams;
   function add(engname: string; Firepower, firesmax, Firerange,
  AmmoMax, Armor, HitsMax, ScanRange, MoveMax: byte; hasconnector: byte; Cost: Smallint;
  GruzMax: TMXRES; obtacle:TObtacle; canmove: TMoveCost;
  Size: TMGSize; name:string;BuyEnable:FTbuyEnable;drawproc:TMaxGFunc;Description: string): PUnitupgradehistory;
   procedure load(what:string);
   procedure clear;
   constructor create;
   destructor destroy;override;
   procedure UpgradesToListBox(ListBox:Pcontrol);
   procedure NamesToListBox(LisBox:Pcontrol;land,sea,air,build:boolean);
   function save2stream(strm:PStream):boolean;
   procedure exportToFile(Fname:string);
   procedure exportToINIFile(Fname:string);
   function loadfromstream(strm:Pstream):boolean;
   procedure prepareUnitIcons(color:cardinal=clGray);
end;
function newTUnitupgradehistory:PUnitupgradehistory;

implementation
uses BMaxGPrg;

constructor TunitParams.create;
begin
   def:=nil;
   mk:=0;
   Firepower:=0;
   firesmax:=0;
   Firerange:=0;
   AmmoMax:=0;
   Armor:=0;
   HitsMax:=0;
   ScanRange:=0;
   MoveMax:=0;
   Cost:=0;
end;

destructor TunitParams.destroy;
begin
   def:=nil;
  inherited;
end;

function newTUnitupgradehistory:PUnitupgradehistory;
begin
   new(result,create);
   result.def:=nil;
   setlength(result.upg,0);
   result.info.picnum:=0;
   result.info.ENGname:='';
   result.info.name:='';
   result.info.Description:='';
   result.info.Draw:=ppck.DrawIconEverytime;
   setlength(result.info.DefFunc.procs,0);
   result.info.DefFunc.count:=-1;
   result.info.size:=sz(0,0);
   result.info.canmove:=nil;
   result.info.GruzMAX:=MxRes(0,0,0,0,0);
   result.info.hasconnector:=0;
   result.info.obtacle:=nil;
   result.info.buyenable:=ppck.StandartBuySell;
   result.info.Ficon:=ppck.StandartIcon;
   result.info.icon:=nil;
   result.info.ricon:=nil;
   result.info.fwicon:=nil;
end;

destructor TUnitupgradehistory.destroy;
var f1:integer;
begin
setlength(info.ENGname,0);
setlength(info.name,0);
setlength(info.description,0);
   if def<>nil then begin
      def.Free;
      def:=nil;
   end;
   upgcount:=high(upg);
   for f1:=0 to upgcount do begin
      if upg[f1]<>nil then begin
         upg[f1].Free;
         upg[f1]:=nil;
      end;
   end;
   if info.icon<>nil then info.icon.Free;info.icon:=nil;
{$IFDEF NORFWICONS}
   info.ricon:=nil;
   info.fwicon:=nil;
{$ELSE}
   if info.ricon<>nil then info.ricon.Free;info.ricon:=nil;
   if info.fwicon<>nil then info.fwicon.Free;info.fwicon:=nil;
{$ENDIF}   
   info.Ficon:=nil;
  inherited;
end;

procedure TUnitupgradehistory.load(engname: string; Firepower, firesmax, Firerange,
  AmmoMax, Armor, HitsMax, ScanRange, MoveMax: byte;
  hasconnector: byte; Cost: Smallint;
  GruzMax: TMXRES; obtacle:Tobtacle; canmove: TMoveCost;
   Size: TMGSize; name:string;BuyEnable:FTbuyEnable;drawproc:TMaxGFunc;Description: string);
begin

  if def=nil then def:=TDefunitParams.Create;
  Def.Firepower:=Firepower;
  Def.firesmax:=firesmax;
  Def.Firerange:=Firerange;
  Def.AmmoMax:=AmmoMax;
  Def.Armor:=Armor;
  Def.HitsMax:=HitsMax;
  Def.ScanRange:=ScanRange;
  Def.MoveMax:=MoveMax;
  Def.Cost:=Cost;
  setlength(upg,1);
  if upg[0]=nil then upg[0]:=TunitParams.create;
  upg[0].locked:=1;
  upg[0].mk:=0;
  upg[0].def:=def;
  Upg[0].Firepower:=Firepower;
  Upg[0].firesmax:=firesmax;
  Upg[0].Firerange:=Firerange;
  Upg[0].AmmoMax:=AmmoMax;
  Upg[0].Armor:=Armor;
  Upg[0].HitsMax:=HitsMax;
  Upg[0].ScanRange:=ScanRange;
  Upg[0].MoveMax:=MoveMax;
  Upg[0].Cost:=Cost;
  info.canmove:=canmove;
  info.hasconnector:=hasconnector;
  info.Size:=Size;
  info.GruzMAX:=GruzMax;
  Info.ENGname:=Engname;
  info.name:=name;
  info.Draw:=drawproc;
  info.Description:=Description;
  info.obtacle:=Obtacle;
  info.buyEnable:=BuyEnable;
  if info.hasconnector=1
     then info.defOptions.AutoTransfer:=1
     else info.defOptions.AutoTransfer:=0;
  if summ(info.GruzMAX)>0 then begin info.defOptions.LoadIn:=128;info.defOptions.LoadOut:=128;end;
end;

procedure TUnitupgradehistory.load(what: string);
var f1:integer;
begin
if what='AddUpgrade' then begin
   upgcount:=high(upg)+1;
   if upgcount<=0 then begin
      load('ClearUpgrades');
      exit;
   end;
   setlength(upg,upgcount+1);
   if upg[upgcount]=nil then upg[upgcount]:=TunitParams.create;
   upg[upgcount].mk:=upgcount;
   upg[upgcount].def:=upg[upgcount-1].def;
   Upg[upgcount].Firepower:=upg[upgcount-1].Firepower;
   Upg[upgcount].firesmax:=upg[upgcount-1].firesmax;
   Upg[upgcount].Firerange:=upg[upgcount-1].Firerange;
   Upg[upgcount].AmmoMax:=upg[upgcount-1].AmmoMax;
   Upg[upgcount].Armor:=upg[upgcount-1].Armor;
   Upg[upgcount].HitsMax:=upg[upgcount-1].HitsMax;
   Upg[upgcount].ScanRange:=upg[upgcount-1].ScanRange;
   Upg[upgcount].MoveMax:=upg[upgcount-1].MoveMax;
   Upg[upgcount].Cost:=upg[upgcount-1].Cost;
end;
if what='ClearUpgrades' then begin
   upgcount:=high(upg);
   for f1:=0 to upgcount do begin
      if upg[f1]<>nil then begin
         upg[f1].Free;
         upg[f1]:=nil;
      end;
   end;
   setlength(upg,1);
   if upg[0]=nil then upg[0]:=Tunitparams.create;
  upg[0].locked:=0;
  upg[0].mk:=0;
  upg[0].def:=def;
  Upg[0].Firepower:=def.Firepower;
  Upg[0].firesmax:=def.firesmax;
  Upg[0].Firerange:=def.Firerange;
  Upg[0].AmmoMax:=def.AmmoMax;
  Upg[0].Armor:=def.Armor;
  Upg[0].HitsMax:=def.HitsMax;
  Upg[0].ScanRange:=def.ScanRange;
  Upg[0].MoveMax:=def.MoveMax;
  Upg[0].Cost:=def.Cost;
end;
end;

function TUnitupgradehistory.Params(mk:integer=-1): Tunitparams;
begin
result:=nil;
if mk=last then mk:=upgcount;
if mk<=upgcount then begin
   if upg[mk]<>nil then result:=upg[mk];
end;
end;

function TunitParams.loadfromstream(strm:Pstream):boolean;
begin
   strm.Read(locked,1);
   def:=nil;
   strm.Read(mk,2);
   strm.Read(Firepower,1);
   strm.Read(firesmax,1);
   strm.Read(Firerange,1);
   strm.Read(AmmoMax,1);
   strm.Read(Armor,1);
   strm.Read(HitsMax,1);
   strm.Read(ScanRange,1);
   strm.Read(MoveMax,1);
   strm.Read(Cost,sizeof(Cost));
result:=true;
end;

function TunitParams.Maxparams: Tcurparams;
begin
result.fires:=firesmax;
result.Ammo:=ammomax;
result.Hits:=hitsmax;
result.Move:=movemax;
result.gruz:=MXRES(0,0,0,0,0);
end;

function TunitParams.save2stream(strm:Pstream):boolean;
begin
   strm.Write(locked,1);
   strm.Write(mk,2);
   strm.Write(Firepower,1);
   strm.Write(firesmax,1);
   strm.Write(Firerange,1);
   strm.Write(AmmoMax,1);
   strm.Write(Armor,1);
   strm.Write(HitsMax,1);
   strm.Write(ScanRange,1);
   strm.Write(MoveMax,1);
   strm.Write(Cost,sizeof(Cost));
   result:=true;
end;

function TUpgradeLevel.add(engname: string; Firepower, firesmax, Firerange,
  AmmoMax, Armor, HitsMax, ScanRange, MoveMax: byte; hasconnector: byte; Cost: Smallint;
  GruzMax: TMXRES; obtacle:TObtacle; canmove: TMoveCost;
  Size: TMGSize; name:string;BuyEnable:FTbuyEnable;drawproc:TMaxGFunc;Description: string): PUnitupgradehistory;
begin
  UnitsCount:=high(units)+1;
  setlength(units,UnitsCount+1);
  if units[UnitsCount]=nil then units[UnitsCount]:=NewTUnitupgradehistory;
  units[UnitsCount].load(engname, Firepower, firesmax, Firerange,
  AmmoMax, Armor, HitsMax, ScanRange, MoveMax, hasconnector, Cost,
  GruzMax, obtacle, canmove, Size, name,BuyEnable,drawproc,
  Description);
  units[UnitsCount].SelfID:=UnitsCount;
  units[unitscount].def.selfID:=unitscount;
  result:=units[UnitsCount];

end;

procedure TUpgradeLevel.clear;
var f1:integer;
begin
   UnitsCount:=high(units);
   for f1:=0 to UnitsCount do begin
      if units[f1]<>nil then begin
         units[f1].Free;
         units[f1]:=nil;
      end;
   end;
   setlength(units,0);
end;

constructor TUpgradeLevel.create;
begin
  setlength(units,0);
  UnitsCount:=-1;
  load('Default');
end;

destructor TUpgradeLevel.destroy;
begin
  clear;

  inherited;
end;

procedure TUpgradeLevel.load(what: string);
var f1:integer;
begin
if what='ClearUpgrades' then begin
  for f1:=0 to UnitsCount do begin
     if units[f1]<>nil then units[f1].load('ClearUpgrades');
  end;
end;
if what='Default' then begin
clear;
with ppck do begin
add(                 'Scout', 12,  1,  3, 10,  4, 16,  9, 12, 0,  9,  res('ResNone'),       StandartObtacle,    AmphibiaUnitTCost, Size1x1,                     '',   StandartBuySell, DrawIconEverytime, '   .    ,  .   .  .');
add(              'Surveyor',  0,  0,  0,  0,  4, 16,  3,  7, 0,  9,  res('ResNone'),       StandartObtacle,    SurveyorUnitTCost, Size1x1,                    '',   StandartBuySell, DrawIconEverytime, ' -.   .         ...   -    .');
add(     'Personnel Carrier',  0,  0,  0,  0,  8, 24,  4, 10, 0, 12,  res('ResNone'),       StandartObtacle,    AmphibiaUnitTCost, Size1x1,                       '',   StandartBuySell, DrawIconEverytime, '     ...   .   ,    .     ,   ...        .');
add(              'Engineer',  0,  0,  0,  0,  4, 14,  3,  6, 0, 18,  res('Metall',40),     StandartObtacle,    AmphibiaUnitTCost, Size1x1,                   '',   StandartBuySell, DrawIconEverytime, '      ,    .   .   2 .   .');
add(           'Constructor',  0,  0,  0,  0,  6, 24,  3,  6, 0, 24,  res('Metall',60),     StandartObtacle,    AmphibiaUnitTCost, Size1x1,               '',   StandartBuySell, DrawIconEverytime, '       .    2 .   .');
add(              'Infantry', 16,  1,  4,  4,  2,  8,  4,  5, 0,  6,  res('ResNone'),       StandartObtacle,   LandBeachUnitTCost, Size1x1,                 '',   StandartBuySell, DrawIconEverytime, ' ...     ...        ''    .   .');
add(                  'Tank', 16,  2,  4, 14, 10, 24,  4,  6, 0, 12,  res('ResNone'),       StandartObtacle,        LandUnitTCost, Size1x1,                      '',   StandartBuySell, DrawIconEverytime, '    ...   .      .        - .');
add(  'Mobile Anti-Aircraft', 16,  1,  7, 10,  4, 24,  4,  7, 0, 18,  res('ResNone'),       StandartObtacle,   LandBeachUnitTCost, Size1x1,         ' ',   StandartBuySell, DrawIconEverytime, '         .     ...   ...      .');
add(           'Assault Gun', 18,  2,  6, 14,  4, 24,  5, 12, 0, 24,  res('ResNone'),       StandartObtacle,        LandUnitTCost, Size1x1,                       '',   StandartBuySell, DrawIconEverytime, '     .   ,          .');
add(       'Rocket Launcher', 15,  2,  7, 16,  4, 24,  4,  6, 0, 24,  res('ResNone'),       StandartObtacle,        LandUnitTCost, Size1x1,                 '',   StandartBuySell, DrawIconEverytime, '  ,   .        2  (    ).');
add(           'Infiltrator',  6,  1,  4, 12,  2,  8,  4,  5, 0, 27,  res('ResNone'),       StandartObtacle,   LandBeachUnitTCost, Size1x1,              '',      NoBuyButSell, DrawIconEverytime, '     ...        ,      ...       .     ,   .  ... :(');
add(       'Missile Crawler', 22,  1, 10,  6,  4, 24,  4,  6, 0, 36,  res('ResNone'),       StandartObtacle,        LandUnitTCost, Size1x1,          ' ',   StandartBuySell, DrawIconEverytime, '  .  ,      ...   ...              .        ?  !');
add(            'Mine Layer',  0,  0,  0,  0,  4, 24,  4,  7, 0,  9,  res('Metall',50),     StandartObtacle,        LandUnitTCost, Size1x1,                     '',   StandartBuySell, DrawIconEverytime, '   .      ( ).     (   ).              ...');
add(                'Scaner',  0,  0,  0,  0,  4, 24, 14,  7, 0, 12,  res('ResNone'),       StandartObtacle,        LandUnitTCost, Size1x1,                    '',   StandartBuySell, DrawIconEverytime, '   .    .     .     ...     - ... (  -)');
add(          'Supply Truck',  0,  0,  0,  0,  4, 24,  3,  7, 0, 12,  res('Metall',50),     StandartObtacle,        LandUnitTCost, Size1x1,        ' ',   StandartBuySell, DrawIconEverytime, '     .     ,     .    ...');
add(            'Gold Truck',  0,  0,  0,  0,  4, 24,  3,  7, 0, 12,  res('Gold',50  ),     StandartObtacle,        LandUnitTCost, Size1x1,                 '',   StandartBuySell, DrawIconEverytime, '       ...       ?   ,      ...');
add(            'Fuel Truck',  0,  0,  0,  0,  4, 20,  3,  7, 0, 12,  res('Fuel',50  ),     StandartObtacle,        LandUnitTCost, Size1x1,                  '',   StandartBuySell, DrawIconEverytime, '   .      ... ');
add(             'Bulldozer',  0,  0,  0,  0,  4, 14,  3,  7, 0, 15,  res('Metall',30),     StandartObtacle,        LandUnitTCost, Size1x1,                 '',   StandartBuySell, DrawIconEverytime, '       ...      .     "Recycle or Die"...            ...');
add(           'Repair Unit',  0,  0,  0,  0,  4, 20,  3,  7, 0, 15,  res('Metall',30),     StandartObtacle,        LandUnitTCost, Size1x1,                 '',   StandartBuySell, DrawIconEverytime, '     .  .      ...        ...     ...');

add(                'Escort', 22,  1,  7, 24,  6, 32,  9,  9, 0, 18,  res('ResNone'),       StandartObtacle,         SeaUnitTCost, Size1x1,                    '',   StandartBuySell, DrawIconEverytime, '     .      ...  ...      .');
add(              'Corvette', 14,  2,  5, 14,  6, 32,  5,  9, 0, 18,  res('ResNone'),       StandartObtacle,         SeaUnitTCost, Size1x1,                    '',   StandartBuySell, DrawIconEverytime, '    ,     .      .      ...         ... ');
add(             'Submarine', 20,  2,  4, 16,  2, 24,  6,  7, 0, 18,  res('ResNone'),       StandartObtacle,         SeaUnitTCost, Size1x1,                 '',   StandartBuySell, DrawIconEverytime, '     ...    .       ...     ...      , ...');
add(               'GunBoat', 20,  2,  7, 14, 12, 32,  4,  7, 0, 24,  res('ResNone'),       StandartObtacle,         SeaUnitTCost, Size1x1,                   '',   StandartBuySell, DrawIconEverytime, '   .           .           .         ...');
add(       'Missile Cruiser', 28,  1, 10, 10,  6, 28,  4,  7, 0, 36,  res('ResNone'),       StandartObtacle,         SeaUnitTCost, Size1x1,          ' ',   StandartBuySell, DrawIconEverytime, '            ...          .     -  ...');
add(         'Sea Transport',  0,  0,  0,  0, 12, 32,  3,  7, 0, 12,  res('ResNone'),       StandartObtacle,    SeaBeachUnitTCost, Size1x1,            '. ',   StandartBuySell, DrawIconEverytime, '  .  6 .    .             - .    ...');
add(            'Cargo Ship',  0,  0,  0,  0, 12, 32,  3,  7, 0, 12,  res('Metall',50),     StandartObtacle,    SeaBeachUnitTCost, Size1x1,                  '',   StandartBuySell, DrawIconEverytime, '...        ...       ,  -       ...');
add(        'Sea Mine Layer',  0,  0,  0,  0,  8, 28,  4,  9, 0, 18,  res('Metall',30),     StandartObtacle,         SeaUnitTCost, Size1x1,           ' ',   StandartBuySell, DrawIconEverytime, '    ...        ...       ... ...   .');

add(               'Fighter', 16,  1,  5,  4,  4, 12,  5, 24, 0, 24,  res('ResNone'),             NoObtacle,         AirUnitTCost, Size1x1,               '',      NoBuyButSell, DrawIconEverytime, '  .  ,      ...   -  "-"...     ...            ...');
add(   'Ground Attack Plane', 18,  2,  4, 12,  4, 18,  5, 18, 0, 30,  res('ResNone'),             NoObtacle,         AirUnitTCost, Size1x1,                 '',      NoBuyButSell, DrawIconEverytime, ' ... , ,  (  )...    ...       ... ...          ...   .');
add(         'Air Transport',  0,  0,  0,  0,  4, 18,  5, 18, 0, 18,  res('ResNone'),             NoObtacle,         AirUnitTCost, Size1x1,             '',      NoBuyButSell, DrawIconEverytime, '             ...    ...');
add(                  'AWAC',  0,  0,  0,  0,  4, 18, 12, 18, 0, 18,  res('ResNone'),             NoObtacle,         AirUnitTCost, Size1x1,                      '',      NoBuyButSell, DrawIconEverytime, '    . ,   ...      ,              ...');

add(             'Land Mine', 28,  1,  0,  1,  0,  2,  1,  0, 0,  2,  res('ResNone'),             NoObtacle,        LandUnitTCost, Size1x1,             ' ',   StandartBuySell, DrawIconOnRepaint, '                   -     ...  ,       ,        ?');
add(              'Sea Mine', 28,  1,  0,  1,  0,  2,  1,  0, 0,  2,  res('ResNone'),             NoObtacle,         SeaMineTCost, Size1x1,              ' ',   StandartBuySell, DrawIconOnRepaint, '           ...     ,          ...           ');
add(            'Gun Turret', 16,  2,  6, 14, 12, 24,  4,  0, 1,  8,  res('ResNone'),       StandartObtacle,   LandStructureTCost, Size1x1,                 ' ',   StandartBuySell, DrawIconEverytime, '  .  ,  ... ... -  ...        ? :            1     ...  .');
add(         'Anti-Aircraft', 16,  2,  8, 20,  8, 24,  4,  0, 1, 12,  res('ResNone'),       StandartObtacle,   LandStructureTCost, Size1x1,                   '',   StandartBuySell, DrawIconEverytime, ',   .          ,        .           ,       .');
add(             'Artillery', 18,  2,  8, 16,  9, 24,  4,  0, 1, 16,  res('ResNone'),       StandartObtacle,   LandStructureTCost, Size1x1,                '',   StandartBuySell, DrawIconEverytime, '   .                     ...           .');
add(      'Missile Launcher', 28,  1, 11, 10,  6, 24,  4,  0, 1, 24,  res('ResNone'),       StandartObtacle,   LandStructureTCost, Size1x1,            '.',   StandartBuySell, DrawIconEverytime, '      ,     ...  ,  ,       ...');
add(             'Connector',  0,  0,  0,  0,  8, 14,  1,  0, 1,  2,  res('ResNone'),             NoObtacle,       ConnectorTCost, Size1x1,               '',   StandartBuySell, DrawIconOnRepaint, '            ...        .           ');
add(                  'Road',  0,  0,  0,  0,  0,  2,  0,  0, 0,  2,  res('ResNone'),           RoadObtacle,   LandStructureTCost, Size1x1,                    '',   StandartBuySell, DrawIconOnRepaint, '         .  ?    !           .');
add(        'Water Platform',  0,  0,  0,  0,  6, 10,  1,  0, 0,  2,  res('ResNone'),   WatrPlatformObtacle,    SeaStructureTCost, Size1x1,          ' ',   StandartBuySell, DrawIconOnRepaint, '         .              ...    , ?');
add(        'Concrete Block',  0,  0,  0,  0, 14, 24,  1,  0, 1,  2,  res('ResNone'),       StandartObtacle,   LandStructureTCost, Size1x1,             ' ',   StandartBuySell, DrawIconOnRepaint, '     ...        ...   ...');
add(                'Bridge',  0,  0,  0,  0,  8, 20,  1,  0, 0,  2,  res('ResNone'),         BridgeObtacle,    SeaStructureTCost, Size1x1,            ' ',   StandartBuySell, DrawIconOnRepaint, '    .            .              ( ?).');
add(          'Storage Unit',  0,  0,  0,  0,  8, 14,  3,  0, 1,  4,  res('Metall',50),     StandartObtacle,   LandStructureTCost, Size1x1,                 '',   StandartBuySell, DrawIconOnRepaint, '     ()');
add(             'Fuel Tank',  0,  0,  0,  0,  6, 14,  3,  0, 1,  4,  res('Fuel',50  ),     StandartObtacle,   LandStructureTCost, Size1x1,        ' ',   StandartBuySell, DrawIconOnRepaint, '     ()');
add(            'Gold Vault',  0,  0,  0,  0,  8, 14,  3,  0, 1,  4,  res('Gold',50  ),     StandartObtacle,   LandStructureTCost, Size1x1,           '',   StandartBuySell, DrawIconOnRepaint, '...    - ...   .  ...     ... ?');
add(           'Landing Pad',  0,  0,  0,  0,  8, 14,  3,  0, 0,  4,  res('ResNone'),       StandartObtacle,   LandStructureTCost, Size1x1,         ' ',   StandartBuySell, DrawIconOnRepaint, '        .             ...        .   .');
add(       'Power Generator',  0,  0,  0,  0,  8, 14,  3,  0, 1,  8,  res('ResNone'),       StandartObtacle,   LandStructureTCost, Size1x1,           '',   StandartBuySell, DrawIconOnRepaint, '        .  2    1 .   .');
add(              'Barracks',  0,  0,  0,  0, 12, 56,  3,  0, 1, 10,  res('ResNone'),       StandartObtacle,   LandStructureTCost, Size2x2,                   '',   StandartBuySell, DrawIconOnRepaint, '           ...     ...           ...      .');
add(                 'Depot',  0,  0,  0,  0, 12, 56,  3,  0, 1, 12,  res('ResNone'),       StandartObtacle,   LandStructureTCost, Size2x2,                     '',   StandartBuySell, DrawIconOnRepaint, '     .      ...');
add(                  'Dock',  0,  0,  0,  0, 12, 56,  3,  0, 1, 12,  res('ResNone'),       StandartObtacle,    SeaStructureTCost, Size2x2,                       '',   StandartBuySell, DrawIconOnRepaint, '     .    ,    ...    ');
add(                'Hangar',  0,  0,  0,  0, 12, 56,  3,  0, 1, 16,  res('ResNone'),       StandartObtacle,   LandStructureTCost, Size2x2,                 '',   StandartBuySell, DrawIconOnRepaint, '     .');
add(   'Light Vehicle Plant',  0,  0,  0,  0,  8, 56,  3,  0, 1, 20,  res('ResNone'),       StandartObtacle,   LandStructureTCost, Size2x2,      '  ',   StandartBuySell, DrawIconOnRepaint, '    , ,     .         .');
add(                 'Radar',  0,  0,  0,  0,  8, 24, 18,  0, 1, 18,  res('ResNone'),       StandartObtacle,   LandStructureTCost, Size1x1,                     '',   StandartBuySell, DrawIconEverytime, '   .   .            ?        ... ');
add(               'Habitat',  0,  0,  0,  0,  8, 56,  3,  0, 1, 20,  res('ResNone'),       StandartObtacle,   LandStructureTCost, Size2x2,            ' ',   StandartBuySell, DrawIconOnRepaint, '   ...                3  .');
add(             'EcoSphere',  0,  0,  0,  0,  8, 56,  3,  0, 1, 20,  res('ResNone'),       StandartObtacle,   LandStructureTCost, Size2x2,                  '',   StandartBuySell, DrawIconOnRepaint, '...     ,  .   ...     ...         ... ...      ...');
add(         'Training Hall',  0,  0,  0,  0,  8, 56,  3,  0, 1, 20,  res('ResNone'),       StandartObtacle,   LandStructureTCost, Size2x2,         ' ',   StandartBuySell, DrawIconOnRepaint, '      .                 ...        ...');
add(         'Gold Refinery',  0,  0,  0,  0,  8, 56,  3,  0, 1, 24,  res('ResNone'),       StandartObtacle,   LandStructureTCost, Size2x2,           '',   StandartBuySell, DrawIconOnRepaint, ', , , ...           ...               ...      ,     .');
add(         'Power Station',  0,  0,  0,  0,  8, 56,  3,  0, 1, 24,  res('ResNone'),       StandartObtacle,   LandStructureTCost, Size2x2,             '',   StandartBuySell, DrawIconOnRepaint, '   -  .  6     6     .');
add(       'Research Center',  0,  0,  0,  0,  8, 56,  3,  0, 1, 24,  res('ResNone'),       StandartObtacle,   LandStructureTCost, Size2x2,  ' ',   StandartBuySell, DrawIconOnRepaint, '          ...      ...             ...        ...');
add(        'Mining Station',  0,  0,  0,  0,  8, 56,  3,  0, 1, 24,  res('Metall',25),     StandartObtacle,   LandStructureTCost, Size2x2,          ' ',       MineBuySell, DrawIconOnRepaint, '     ...   .       ...   .     .');
add(   'Heavy Vehicle Plant',  0,  0,  0,  0,  8, 56,  3,  0, 1, 40,  res('ResNone'),       StandartObtacle,   LandStructureTCost, Size2x2,     '  ',   StandartBuySell, DrawIconOnRepaint, '   ,    .   3 .     .   .');
add(              'ShipYard',  0,  0,  0,  0,  8, 56,  3,  0, 1, 40,  res('ResNone'),       StandartObtacle,    SeaStructureTCost, Size2x2,                 '',   StandartBuySell, DrawIconOnRepaint, '              ...      ...    3   1 . ');
add(        'Air Unit Plant',  0,  0,  0,  0,  8, 56,  3,  0, 1, 40,  res('ResNone'),       StandartObtacle,   LandStructureTCost, Size2x2,                 '',   StandartBuySell, DrawIconOnRepaint, '     ...    ...   ...     .    3 .   1 . .');

add(         'Alien Gunboat', 28,  2,  8, 10, 18, 40,  4,  7, 0, 36,  res('ResNone'),       StandartObtacle,    SeaBeachUnitTCost, Size1x1,      ' ',      NoBuyButSell, DrawIconEverytime, ' ...     ?   ,  ,     ...          ...           ');
add(            'Alien Tank', 20,  3,  5, 15, 14, 32,  4,  8, 0, 18,  res('ResNone'),       StandartObtacle,   LandBeachUnitTCost, Size1x1,           ' ',      NoBuyButSell, DrawIconEverytime, '     ...     ...     ...          ...   .');
add(     'Alien Assault Gun', 25,  3,  7, 15,  8, 32,  5, 16, 0, 28,  res('ResNone'),       StandartObtacle,   LandBeachUnitTCost, Size1x1,      ' ',      NoBuyButSell, DrawIconEverytime, ' ...  ...    ,  ... ...       ...        ?        ...');
add(     'Alien Interceptor', 25,  2,  5, 10,  6, 20,  5, 18, 0, 30,  res('ResNone'),             NoObtacle,         AirUnitTCost, Size1x1,        ' ',      NoBuyButSell, DrawIconEverytime, '  ...  ...    " "     -      ...    ...   ...    ...  ...');

    end;
end;

end;

function TUpgradeLevel.loadfromstream(strm:Pstream):boolean;
var f1,f2:integer;
var b:byte;
begin
strm.Read(f1,sizeof(f1));
clear;
load('Default');
UnitsCount:=high(units);
if f1>Unitscount then begin
  unitscount:=f1;
  setlength(units,unitscount+1);
end;
for f2:=0 to f1 do begin
   strm.Read(b,1);
   if b=31 then begin
      if units[f2]=nil then units[f2]:=NewTunitUpgradeHistory;
      units[f1].loadfromstream(strm);
   end;
end;
for f2:=f1+1 to unitscount do begin
   if units[f2]<>nil then units[f2].free;
   units[f2]:=nil;
end;
result:=true;
end;

function TUpgradeLevel.FindBy(ENGRUSName: string): PUnitupgradehistory;
var f1:integer;
begin
result:=nil;
for f1:=0 to UnitsCount do begin
   if units[f1]<>nil then begin
      if (units[f1].info.ENGname=ENGRUSName)or(units[f1].info.name=ENGRUSName)then begin
         result:=units[f1];
         exit;
      end;
   end;
end;
end;

function TUpgradeLevel.Params(UtypeID, mk: integer): Tunitparams;
var Tuh:PUnitupgradehistory;
begin
result:=nil;
Tuh:=FindBy(UtypeId);
if Tuh<>nil then result:=tuh.params(mk);
end;

function TUpgradeLevel.save2stream(strm:Pstream):boolean;
var f1:integer;
var b:byte;
begin
UnitsCount:=high(units);
strm.Write(unitscount,sizeof(unitscount));
for f1:=0 to unitscount do begin
   b:=52;
   if units[f1]<>nil then begin
      b:=31;
      strm.Write(b,1);
      units[f1].save2stream(strm);
   end else strm.Write(b,1);
end;
result:=true;
end;

function TUpgradeLevel.FindBy(UtypeID: integer): PUnitupgradehistory;
begin
result:=nil;
if UtypeID<=UnitsCount then begin
   if units[UtypeID]<>nil then result:=units[UtypeID];
end else begin
   showmessage('       '+
      int2str(UtypeID)+#13+
      '   '+int2str(UnitsCount)+' '+#13+
      '    66');
end;
end;

procedure TUnitupgradehistory.Upgrade(parId: string; var qty, costUP,
  costDOWN: integer);
var dv,up:smallint;
var perc:single;
begin
dv:=0;up:=0;qty:=0;costUP:=0;costDOWN:=0;
if def=nil then exit;
if parID='Firepower' then begin dv:=def.Firepower;up:=upg[upgcount].Firepower-def.Firepower;end;
if parID='Firesmax' then begin  dv:=def.firesmax; up:=upg[upgcount].firesmax-def.firesmax;end;
if parID='Firerange' then begin dv:=def.Firerange;up:=upg[upgcount].Firerange-def.Firerange;end;
if parID='AmmoMax' then begin   dv:=def.AmmoMax;  up:=upg[upgcount].AmmoMax-def.AmmoMax;end;
if parID='Armor' then begin    dv:=def.Armor; up:=upg[upgcount].Armor-def.Armor;end;
if parID='HitsMax' then begin  dv:=def.HitsMax; up:=upg[upgcount].HitsMax-def.HitsMax;end;
if parID='ScanRange' then begin dv:=def.ScanRange;up:=upg[upgcount].ScanRange-def.ScanRange;end;
if parID='MoveMax' then begin  dv:=def.MoveMax;up:=upg[upgcount].MoveMax-def.MoveMax;end;
if dv<100 then qty:=10;
if dv<50 then qty:=5;
if dv<25 then qty:=2;
if dv<10 then qty:=1;
if dv=0 then qty:=0;
if dv=0 then exit;

perc:=((up+qty)/dv)*10;
costUP:=trunc(perc*perc*perc/2)+1;
perc:=(up/dv)*10;
costDOWN:=trunc(perc*perc*perc/2)+1;
if up=0 then costDown:=0;
end;

function TUnitupgradehistory.Params(parID: string): integer;
begin
result:=0;
if parID='MetallMAX' then begin result:=info.GruzMAX.metall;end;
if parID='FuelMAX'   then begin result:=info.GruzMAX.fuel;end;

if parID='Firepower' then begin result:=upg[upgcount].Firepower;end;
if parID='Firesmax'  then begin result:=upg[upgcount].Firesmax;end;
if parID='Firerange' then begin result:=upg[upgcount].Firerange;end;
if parID='AmmoMax'   then begin result:=upg[upgcount].AmmoMax;end;
if parID='Armor'     then begin result:=upg[upgcount].Armor;end;
if parID='HitsMax'   then begin result:=upg[upgcount].HitsMax;end;
if parID='ScanRange' then begin result:=upg[upgcount].ScanRange;end;
if parID='MoveMax'   then begin result:=upg[upgcount].MoveMax;end;
if parID='Cost'      then begin result:=upg[upgcount].Cost;end;

if parID='Self' then result:=integer(@self);
end;

function TUnitupgradehistory.Upgrade(parId, updown: string; money: integer): integer;
var qt,Cup,Cdown:integer;
var ok:boolean;
begin
upgrade(parID,qt,cup,cdown);
result:=0;
if updown='+' then begin if (money>cup)and(cup>0)then begin result:=cup;end;end;
if updown='-' then begin if Cdown>0 then begin result:=-cdown;qt:=-qt;end;end;
if (qt<>0)and(result<>0) then begin
   if upg[upgcount].locked=1 then begin
      load('AddUpgrade');
   end;
   if ParId='Firepower' then upg[upgcount].Firepower:=upg[upgcount].Firepower+qt;
   if ParId='Firesmax'  then upg[upgcount].Firesmax:=upg[upgcount].Firesmax+qt;
   if ParId='Firerange' then upg[upgcount].Firerange:=upg[upgcount].Firerange+qt;
   if ParId='AmmoMax'   then upg[upgcount].AmmoMax:=upg[upgcount].AmmoMax+qt;
   if ParId='Armor'     then upg[upgcount].Armor:=upg[upgcount].Armor+qt;
   if ParId='HitsMax'   then upg[upgcount].HitsMax:=upg[upgcount].HitsMax+qt;
   if ParId='ScanRange' then upg[upgcount].ScanRange:=upg[upgcount].ScanRange+qt;
   if ParId='MoveMax'   then upg[upgcount].MoveMax:=upg[upgcount].MoveMax+qt;
   if ParId='Cost'      then upg[upgcount].Cost:=upg[upgcount].Cost-qt;
end;
if (upgcount>0) then begin

  ok:=false;
  if upg[upgcount].Firepower<>upg[upgcount-1].Firepower then ok:=true;
  if upg[upgcount].Firesmax <>upg[upgcount-1].Firesmax then ok:=true;
  if upg[upgcount].Firerange<>upg[upgcount-1].Firerange then ok:=true;
  if upg[upgcount].AmmoMax  <>upg[upgcount-1].AmmoMax then ok:=true;
  if upg[upgcount].Armor    <>upg[upgcount-1].Armor then ok:=true;
  if upg[upgcount].HitsMax  <>upg[upgcount-1].HitsMax then ok:=true;
  if upg[upgcount].ScanRange<>upg[upgcount-1].ScanRange then ok:=true;
  if upg[upgcount].MoveMax  <>upg[upgcount-1].MoveMax then ok:=true;
  if upg[upgcount].Cost     <>upg[upgcount-1].Cost then ok:=true;
  if (ok=false)and(upg[upgcount].locked=0) then begin
     upg[upgcount].Free;
     upg[upgcount]:=nil;
     setlength(upg,upgcount);
     upgcount:=high(upg);
  end;
end;
end;

function TUnitupgradehistory.Params(parID: string; mode: byte): string;
begin
result:='';
if parID='MetallMAX' then begin result:=int2str(info.GruzMAX.metall);end;
if parID='FuelMAX'   then begin result:=int2str(info.GruzMAX.fuel);end;

if parID='Firepower' then begin result:=int2str(def.Firepower)+'+'+int2str(upg[upgcount].Firepower-def.Firepower)+'='+int2str(upg[upgcount].Firepower);end;
if parID='Firesmax'  then begin result:=int2str(def.Firesmax)+'+'+int2str(upg[upgcount].Firesmax-def.Firesmax)+'='+int2str(upg[upgcount].Firesmax);end;
if parID='Firerange' then begin result:=int2str(def.Firerange)+'+'+int2str(upg[upgcount].Firerange-def.Firerange)+'='+int2str(upg[upgcount].Firerange);end;
if parID='AmmoMax'   then begin result:=int2str(def.AmmoMax)+'+'+int2str(upg[upgcount].AmmoMax-def.AmmoMax)+'='+int2str(upg[upgcount].AmmoMax);end;
if parID='Armor'     then begin result:=int2str(def.Armor)+'+'+int2str(upg[upgcount].Armor-def.Armor)+'='+int2str(upg[upgcount].Armor);end;
if parID='HitsMax'   then begin result:=int2str(def.HitsMax)+'+'+int2str(upg[upgcount].HitsMax-def.HitsMax)+'='+int2str(upg[upgcount].HitsMax);end;
if parID='ScanRange' then begin result:=int2str(def.ScanRange)+'+'+int2str(upg[upgcount].ScanRange-def.ScanRange)+'='+int2str(upg[upgcount].ScanRange);end;
if parID='MoveMax'   then begin result:=int2str(def.MoveMax)+'+'+int2str(upg[upgcount].MoveMax-def.MoveMax)+'='+int2str(upg[upgcount].MoveMax);end;
if parID='Cost'      then begin result:=int2str(def.Cost)+'-'+int2str(upg[upgcount].Cost-def.Cost)+'='+int2str(upg[upgcount].Cost);end;

end;

procedure TUpgradeLevel.exportToFile(Fname: string);
var f:textfile;
var f1:integer;
function x(nm:integer):string;begin str(nm:2,result);end;
function UtpToStr(Utp:Unittypes):string;begin result:='Utpe('+int2str(utp[0])+','+int2str(utp[1])+','+int2str(utp[2])+','+int2str(utp[3])+','+int2str(utp[4])+')';end;
function Restostr(res:TMXRes):String;begin result:='MXRES('+x(res.metall)+','+x(res.fuel)+','+x(res.energy)+','+x(res.humans)+','+x(res.gold)+')';end;
function RestostrEX(res:TMXRes):String;begin
                     result:=' res(';
if res.metall>0 then result:=result+'''Metall'','+x(res.metall) else
if res.fuel  >0 then result:=result+'''Fuel'','+x(res.fuel)+'  ' else
if res.energy>0 then result:=result+'''Energy'','+x(res.energy) else
if res.humans>0 then result:=result+'''Humans'','+x(res.humans) else
if res.gold  >0 then result:=result+'''Gold'','+x(res.gold)+'  ';
if result=' res(' then result:=result+'''ResNone''),  ' else result:=result+'),';
end;
function TerrToStr(terr:terrtpes):string;begin result:='MoveTerr('+x(terr[0])+','+x(terr[1])+','+x(terr[2])+','+x(terr[3])+','+x(terr[4])+','+x(terr[5])+','+x(terr[6])+',0)';end;
function sztostr(sz:TMGSize):string;begin if sz.size=4 then result:='Size2x2' else result:='Size1x1';end;
function ProdTostr(Utp:UCanConstruct):string;begin result:='ProduceR('+int2str(utp[0])+','+int2str(utp[1])+','+int2str(utp[2])+','+int2str(utp[3])+','+int2str(utp[4])+','+int2str(utp[5])+','+int2str(utp[6])+','+int2str(utp[7])+')';;end;
function y(nm:integer):string;begin str(nm:3,result);end;
function s(str:string;m:word=23):string;var qq1:integer;begin result:='';if length(str)<=m then begin for qq1:=length(str) to m do result:=result+' ';end;result:=result+str;end;
function CanMoveToStr(terr:TMoveCost):string;begin if assigned(terr)then begin terr(moveterr(1,1,1,1,1,1,1,1));result:=s(ppck.GetLastFuncName,19);end;end;
function OBToStr(terr:TObtacle):string;begin if assigned(terr)then begin terr(moveterr(1,1,1,1,1,1,1,1));result:=s(ppck.GetLastFuncName,18);end;end;
function Buytostr(terr:FTbuyEnable):string;begin if assigned(terr)then begin terr(false,10);result:=s(ppck.GetLastFuncName,16);end;end;
function Drwtostr(terr:TMaxGFunc):string;var m:array of PObj;begin m:=nil;if assigned(terr)then begin terr(m);result:=s(ppck.GetLastFuncName,16);end;end;
function n(b:boolean):string;begin if b then result:='1' else result:='0'; end;
function JopToStr(utp:UnitCanDO):string;begin result:='CanDo('+int2str(utp[0])+','+int2str(utp[1])+','+int2str(utp[2])+','+int2str(utp[3])+','+int2str(utp[4])+','+int2str(utp[5])+','+int2str(utp[6])+','+int2str(utp[7])+','+int2str(utp[8])+','+int2str(utp[9])+','+int2str(utp[10])+','+int2str(utp[11])+','+int2str(utp[12])+','+int2str(utp[13])+')';end;
function LoadToStr(Utp:UCanLoad):string;begin result:='CanLoad('+int2str(utp[0])+','+int2str(utp[1])+','+int2str(utp[2])+','+int2str(utp[3])+')';end;
function stt(s:string):string;var w1:integer;begin
result:='';for w1:=1 to length(s) do if s[w1]='''' then result:=result+'''' else result:=result+s[w1];end;
begin
assignfile(f,Fname);
rewrite(f);
for f1:=0 to high(units) do begin
if (f1=19)or(f1=27)or(f1=31)or(f1=63)then writeln(f);
write(f,'add(');
write(f,'{EName}',s(''''+units[f1].info.Engname+''''));
write(f,', {Fpower}',x(units[f1].def.Firepower));
write(f,', {Fires}',x(units[f1].def.firesmax));
write(f,', {FRange}',x(units[f1].def.Firerange));
write(f,', {Ammo}',x(units[f1].def.AmmoMax));
write(f,', {Armor}',x(units[f1].def.Armor));
write(f,', {Hits}',x(units[f1].def.HitsMax));
write(f,', {SRange}',x(units[f1].def.ScanRange));
write(f,', {Move}',x(units[f1].def.MoveMax));
write(f,', {Hasconnector}',units[f1].info.Hasconnector);
write(f,', {Cost}',x(units[f1].def.Cost));
write(f,', {GruzMAX}',restostrEX(units[f1].info.GRUZMAX));
write(f,' {Obtacle}',OBToStr(units[f1].info.obtacle));
write(f,', {Canmove}',CanMoveToStr(units[f1].info.Canmove));
write(f,', {Size}',sztostr(units[f1].info.size));
write(f,', {Name}',s(''''+units[f1].info.name+'''',26));
write(f,', {BuyEnable}',Buytostr(units[f1].info.BuyEnable));
write(f,', {Picture}',DrwToStr(Units[f1].info.draw));
write(f,', {Description}''',stt(units[f1].info.description),'''');
writeln(f,');');
end;
closefile(f);
end;

procedure TUpgradeLevel.exportToINIFile(Fname: string);
function stt(s:string):string;var w1:integer;begin
result:='';for w1:=1 to length(s) do if s[w1]='''' then result:=result+'''' else result:=result+s[w1];end;
function Restostr(res:TMXRes):String;begin result:='M('+int2str(res.metall)+')F('+int2str(res.fuel)+')E('+int2str(res.energy)+')H('+int2str(res.humans)+')G('+int2str(res.gold)+')';end;
function ProdTostr(Utp:UCanConstruct):string;begin result:=int2str(utp[0])+int2str(utp[1])+int2str(utp[2])+int2str(utp[3])+int2str(utp[4])+int2str(utp[5])+int2str(utp[6])+int2str(utp[7]);end;
function TerrToStr(terr:terrtpes):string;begin result:=int2str(terr[0])+int2str(terr[1])+int2str(terr[2])+int2str(terr[3])+int2str(terr[4])+int2str(terr[5])+int2str(terr[6])+'0';end;
function UtpToStr(Utp:Unittypes):string;begin result:=int2str(utp[0])+int2str(utp[1])+int2str(utp[2])+int2str(utp[3])+int2str(utp[4]);end;
function LoadToStr(Utp:UCanLoad):string;begin result:=int2str(utp[0])+int2str(utp[1])+int2str(utp[2])+int2str(utp[3]);end;
function JopToStr(utp:UnitCanDO):string;begin result:=int2str(utp[0])+int2str(utp[1])+int2str(utp[2])+int2str(utp[3])+int2str(utp[4])+int2str(utp[5])+int2str(utp[6])+int2str(utp[7])+int2str(utp[8])+int2str(utp[9])+int2str(utp[10])+int2str(utp[11])+int2str(utp[12])+int2str(utp[13]);end;
function sztostr(sz:TMGSize):string;begin if sz.size=4 then result:='4' else result:='1';end;
function CanMoveToStr(terr:TMoveCost):string;begin if assigned(terr)then begin terr(moveterr(1,1,1,1,1,1,1,1));result:=ppck.GetLastFuncName;end;end;
function OBToStr(terr:TObtacle):string;begin if assigned(terr)then begin terr(moveterr(1,1,1,1,1,1,1,1));result:=(ppck.GetLastFuncName);end;end;
var f:PIniFile;
var f1,f2:integer;
var ss:string;
begin
f := OpenIniFile( Fname );
f.Section := 'Main';
f.Mode := ifmRead;
UnitsCount:=high(units);
f1:=f.ValueInteger('UnitsCount',UnitsCount);
f.Mode := ifmWrite;
if f1>Unitscount then begin
   for f2:=f1 to unitscount do begin
      ss:='Unit'+int2str(f2);
      f.Section := ss;
      f.ClearSection;
   end;
end;
f.ValueInteger('UnitsCount',UnitsCount);

for f1:=0 to unitscount do begin
   ss:='Unit'+int2str(f1);
   f.Section := ss;
   f.ValueString('{EName}',units[f1].info.Engname);
   f.ValueInteger('{Fpower}',(units[f1].def.Firepower));
   f.ValueInteger('{Fires}',(units[f1].def.firesmax));
   f.ValueInteger('{FRange}',(units[f1].def.Firerange));
   f.ValueInteger('{Ammo}',(units[f1].def.AmmoMax));
   f.ValueInteger('{Armor}',(units[f1].def.Armor));
   f.ValueInteger('{Hits}',(units[f1].def.HitsMax));
   f.ValueInteger('{SRange}',(units[f1].def.ScanRange));
   f.ValueInteger('{Move}',(units[f1].def.MoveMax));
   f.ValueInteger('{Hasconnector}',units[f1].info.Hasconnector);
   f.ValueInteger('{Cost}',(units[f1].def.Cost));
   f.ValueString('{GruzMAX}',restostr(units[f1].info.GRUZMAX));
   f.ValueString('{Obtacle}',OBToStr(units[f1].info.obtacle));
   f.ValueString('{Canmove}',CanMoveToStr(units[f1].info.Canmove));
   f.ValueString('{Size}',sztostr(units[f1].info.size));
   f.ValueInteger('{Bmp}',(units[f1].info.picnum));
   f.ValueString('{Name}',units[f1].info.name);
   f.ValueString('{Description}',stt(units[f1].info.description));
end;
f.Free;
end;

procedure TUpgradeLevel.NamesToListBox(LisBox: Pcontrol;land,sea,air,build:boolean);
var f1:integer;
var ok:boolean;
begin

unitsCount:=high(Units);
for f1:=0 to unitsCount do begin
   if units[f1]<>nil then begin
      ok:=false;
      if (sea)and(units[f1].info.canmove(moveterr(1,0,0,0,0,0,0,0))>0) then ok:=true;
      if (land)and(units[f1].info.canmove(moveterr(0,0,1,0,0,0,0,0))>0) then ok:=true;
      if (units[f1].info.canmove(moveterr(0,0,0,1,0,0,0,0))>0) then ok:=air;
      if ((ppck.lastfunc=8)or(ppck.lastfunc=10)or(ppck.lastfunc=11))then ok:=build;
      if ok then Lisbox.Add(units[f1].info.ENGname);
   end;
end;
end;

function TDefunitParams.loadfromstream(strm:Pstream):boolean;
begin
   strm.Read(selfID,sizeof(selfID));
   strm.Read(Firepower,1);
   strm.Read(firesmax,1);
   strm.Read(Firerange,1);
   strm.Read(AmmoMax,1);
   strm.Read(Armor,1);
   strm.Read(HitsMax,1);
   strm.Read(ScanRange,1);
   strm.Read(MoveMax,1);
   strm.Read(Cost,sizeof(Cost));
result:=true;
end;

function TDefunitParams.save2stream(strm:Pstream):boolean;
begin
   strm.Write(selfID,sizeof(selfID));
   strm.Write(Firepower,1);
   strm.Write(firesmax,1);
   strm.Write(Firerange,1);
   strm.Write(AmmoMax,1);
   strm.Write(Armor,1);
   strm.Write(HitsMax,1);
   strm.Write(ScanRange,1);
   strm.Write(MoveMax,1);
   strm.Write(Cost,sizeof(Cost));
result:=true;
end;

function TUnitupgradehistory.loadfromstream(strm:Pstream):boolean;
var f1,f2:integer;
var b:byte;
begin
result:=false;
strm.Read(b,1);
if b<>selfid then exit;
strm.Read(b,1);
if b=44 then begin
   if def=nil then def:=TDefunitParams.Create;
   def.loadfromstream(strm);
end;
strm.Read(f1,sizeof(f1));
upgcount:=high(upg);
if f1<upgcount then begin
   for f2:=f1 to upgcount do if upg[f2]<>nil then begin upg[f2].Free;upg[f2]:=nil;end;
end;
upgcount:=f1;
setlength(upg,upgcount+1);
for f1:=0 to upgcount do begin
   strm.Read(b,1);
   if b=22 then begin
      if upg[f1]=nil then upg[f1]:=Tunitparams.create;
      upg[f1].loadfromstream(strm);
      upg[f1].def:=def;
   end else begin
      if upg[f1]<>nil then begin
         upg[f1].Free;
         upg[f1]:=nil;
      end;
   end;
end;
result:=true;
end;

function TUnitupgradehistory.save2stream(strm:PStream):boolean;
var f1:integer;
var b:byte;
begin
strm.Write(SelfID,1);
b:=20;
if def<>nil then begin
   b:=44;
   strm.Write(b,1);
   def.save2stream(strm);
end else strm.Write(b,1);
upgcount:=high(upg);
strm.Write(upgcount,sizeof(upgcount));
if upgcount>=0 then begin
   for f1:=0 to upgcount do begin
      b:=60;
      if upg[f1]<>nil then begin
         b:=20;
         strm.Write(b,1);
         upg[f1].save2stream(strm);
      end else strm.Write(b,1);
   end;
end;
result:=true;
end;

procedure TUnitupgradehistory.Params(ts: PControl; mode: TstringgridfillType);
var row,colcnt:integer;
var ss:string;
var cu,cd,qt,f1:integer;
procedure incc;
begin
   inc(row);
   if ts.LVCount<(row+1) then ts.LVItemAdd('');
end;
begin
if (PokupkaMode in mode)or(UpgradeMode in mode) then colcnt:=5 else colcnt:=2;
if Fromrow1 in mode then row:=1 else row:=0;
if Fromrow2 in mode then row:=2;
while ts.LVColCount<(colcnt) do ts.LVColAdd('',taLeft,0);
while ts.LVCount<(row+1) do ts.LVItemAdd('');
f1:=str2int(wrt(ts.Caption,'0'));
if (PokupkaMode in mode)then begin
  if prg.newplayer<>nil then
    if (f1>=0)and(f1<=high(prg.newplayer.pokupki))then begin
     ts.LVItems[row,0]:=qty;
     ts.LVItems[row,1]:=int2str(prg.newplayer.pokupki[f1].count);
     ts.LVItems[row,2]:=int2str(prg.newplayer.pokupki[f1].cost);
     if prg.newplayer.pokupki[f1].count>1 then ts.LVItems[row,3]:='-' else ts.LVItems[row,3]:='';
     if prg.newplayer.pokupki[f1].cost<prg.NewPlayer.money then ts.LVItems[row,4]:='+' else ts.LVItems[row,4]:='';
     incc;
  end;
end;
if (GruzInfo in mode)or(GruzMax in mode) then begin
ss:='MetallMAX';
IF Params(ss)>0 then begin
   ts.LVItems[row,0]:=buyMetall;
   ts.LVItems[row,1]:=Params(ss,0);
   if (PokupkaMode in mode)then begin
     ts.LVItems[row,2]:=('1/5');
     ts.LVItems[row,1]:=int2str(prg.newplayer.pokupki[f1].gruz.metall)+'/'+Params(ss,0);
     if prg.newplayer.pokupki[f1].gruz.metall>=5 then ts.LVItems[row,3]:='-' else ts.LVItems[row,3]:='';
     if (prg.newplayer.pokupki[f1].gruz.metall<cardinal(Params(ss))) and
        (prg.newplayer.pokupki[f1].count<=prg.NewPlayer.money) then ts.LVItems[row,4]:='+' else ts.LVItems[row,4]:='';
   end;
   incc;
end;
ss:='FuelMAX';
IF Params(ss)>0 then begin
   ts.LVItems[row,0]:=buyFuel;
   ts.LVItems[row,1]:=Params(ss,0);
   ts.LVItems[row,2]:=('1/5');
   if (PokupkaMode in mode)then begin
   ts.LVItems[row,1]:=int2str(prg.newplayer.pokupki[f1].gruz.fuel)+'/'+Params(ss,0);
   ts.LVItems[row,2]:=('1/5');
     if prg.newplayer.pokupki[f1].gruz.fuel>=5 then ts.LVItems[row,3]:='-' else ts.LVItems[row,3]:='';
     if (prg.newplayer.pokupki[f1].gruz.fuel<cardinal(Params(ss))) and
        (prg.newplayer.pokupki[f1].count<=prg.NewPlayer.money) then ts.LVItems[row,4]:='+' else ts.LVItems[row,4]:='';
   end;
   incc;
end;
end;
if ParamsInfo in mode then begin
for f1:=1 to 9 do begin
ss:=pn[f1];
IF Params(ss)>0 then begin
   ts.LVItems[row,0]:=ss;
   ts.LVItems[row,1]:=Params(ss,0);
   if UpgradeMode in mode then begin
      Upgrade(ss,qt,cu,cd);
      ts.LVItems[row,2]:=int2str(cu);
      if cd>0 then ts.LVItems[row,3]:='-' else ts.LVItems[row,3]:='';
      ts.LVItems[row,4]:='+';
   end;
   incc;
end;
end;
end;
while ts.LVCount>row do ts.lvdelete(ts.lvcount-1);
ts.Caption:=info.name;
end;

procedure TUpgradeLevel.UpgradesToListBox(ListBox: Pcontrol);
var f1,f2:integer;
begin
f2:=listBox.CurIndex;
ListBox.Clear;
for f1:=0 to UnitsCount do begin
   if units[f1]<>nil then begin
      if units[f1].upgcount>0 then ListBox.Add(Units[f1].info.EngName);
   end;
end;
listbox.CurIndex:=f2;
end;

procedure TUpgradeLevel.prepareUnitIcons(color:cardinal=clGray);
var f1:integer;
begin
unitscount:=high(units);
for f1:=0 to unitscount do begin
   if units[f1]<>nil then begin
    if units[f1].info.icon=nil then units[f1].info.icon:=units[f1].info.Ficon(units[f1].info.ENGname,sz2word(units[f1].info.size),color);
{$IFDEF NORFWICONS}
      if units[f1].info.ricon=nil then units[f1].info.ricon:=units[f1].info.icon;
      if units[f1].info.fwicon=nil then units[f1].info.fwicon:=units[f1].info.icon;
{$ELSE}
      if units[f1].info.ricon=nil then units[f1].info.ricon:=units[f1].info.Ficon(units[f1].info.ENGname,sz2word(units[f1].info.size),color,'r');
      if units[f1].info.fwicon=nil then units[f1].info.fwicon:=units[f1].info.Ficon(units[f1].info.ENGname,sz2word(units[f1].info.size),color,'fw');
  {$ENDIF}   end;
end;
end;

end.

