unit BrlgCompiler;

interface
uses SysUtils;
type Tline=record
   i:array of integer;
   icount:integer;
   f:array of real;   
   fcount:integer;
   s:array of string; 
   scount:integer;
   p:array of string;
   pcount:integer;
   v:array of string;
   vcount:integer;
   d:array of byte;
   count:integer;
end;
function empty(w:Tline):Tline;
type tprc=record
   name:string;
   paramscount:integer;
   paramstypes:string;
end;
type TDataBase=class
   separators:array of string;
   scount:integer;
   P:array of TPrc;
   Pcount:integer;

end;

type TbrlgCompiler=class
   database:TDataBase;
   currentline:Tline;
   InString:string;
   procedure load(s:string);
   procedure analyzeInstring;
   constructor create;
   destructor destroy;override;
end;
implementation
function empty(w:Tline):Tline;
var f1:integer;
begin
   setlength(w.i,0);w.i:=nil;w.icount:=-1;
   setlength(w.f,0);w.f:=nil;w.fcount:=-1;
   for f1:=0 to high(w.s) do setlength(w.s[f1],0);setlength(w.s,0);w.s:=nil;w.scount:=-1;
   for f1:=0 to high(w.p) do setlength(w.p[f1],0);setlength(w.p,0);w.p:=nil;w.pcount:=-1;
   for f1:=0 to high(w.v) do setlength(w.v[f1],0);setlength(w.v,0);w.v:=nil;w.vcount:=-1;
   setlength(w.d,0);w.d:=nil;w.count:=-1;
   result:=w;
end;

procedure TbrlgCompiler.analyzeInstring;
var ok:boolean;
var s:string;
begin
   repeat
      s:=getNext;
      if s='' then ok:=true;
   until ok;
end;

constructor TbrlgCompiler.create;
begin
  Instring:='';
end;

destructor TbrlgCompiler.destroy;
begin
  currentline:=empty(currentline);
  setlength(instring,0);
  inherited;
end;

procedure TbrlgCompiler.load(s: string);
begin
   InString:=Instring+' '+s;
end;

end.
